<?php
/******************************************************************************
*                                                                             *
*           Copyright (c) 2004-2007 CS-Cart.com. All rights reserved.         *
*                                                                             *
*******************************************************************************
*                                                                             *
* CS-Cart  is  commercial  software,  only  users  who have purchased a valid *
* license through  http://www.cs-cart.com/  and  accept  to the terms of this *
* License Agreement can install this product.                                 *
*                                                                             *
*******************************************************************************
* THIS  CS-CART  SHOP END-USER LICENSE AGREEMENT IS A LEGAL AGREEMENT BETWEEN *
* YOU  AND  YOUR  COMPANY  (COLLECTIVELY, "YOU") AND CS-CART.COM (HEREINAFTER *
* REFERRED  TO  AS  "THE AUTHOR")  FOR THE SOFTWARE PRODUCT IDENTIFIED ABOVE, *
* WHICH INCLUDES COMPUTER  SOFTWARE AND MAY INCLUDE ASSOCIATED MEDIA, PRINTED *
* MATERIALS,  AND  "ONLINE"  OR  ELECTRONIC  DOCUMENTATION (COLLECTIVELY, THE *
* "SOFTWARE").  BY  USING  THE  SOFTWARE,  YOU  SIGNIFY YOUR AGREEMENT TO ALL *
* TERMS, CONDITIONS, AND NOTICES CONTAINED  OR  REFERENCED HEREIN. IF YOU ARE *
* NOT  WILLING  TO  BE  BOUND  BY  THIS  AGREEMENT, DO NOT INSTALL OR USE THE *
* SOFTWARE.                                                                   *
*                                                                             *
* PLEASE READ THE FULL  TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" *
* FILE PROVIDED WITH THIS  DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE *
* AT THE FOLLOWING URL: http://www.cs-cart.com/license.html                   *
******************************************************************************/

//
// $Id: config.php,v 1.1.1.1 2007/12/13 10:08:01 pshevtsov Exp $
//

if ( !defined('IN_CSCART') ) { die('Access denied'); }

//
// Database tables aliases...
//

$db_tables['gift_certificates'] = 'cscart_gift_certificates';
$db_tables['gift_certificates_log'] = 'cscart_gift_certificates_log';

//
// Defined variables
//

define('STATUSES_GIFT_CERTIFICATE', 'G');
define('GIFT_CERTIFICATE_EXCLUDE_PRODUCTS', 'GC');
define('ORDER_DATA_PURCHASED_GIFT_CERTIFICATES', 'B');
//
// Script targets
//
$script_targets['gift_certificates'] = ADDONS_DIR . 'gift_certificates' .DS. 'targets' .DS. 'gift_certificates.php';

array_push($secure_targets, 'gift_certificates');

$fn_inheritance['fn_generate_cart_id'][] = array ('function' => 'fn_giftcert_generate_cart_id', 'params' => array('_cid', 'extra'));
$fn_inheritance['fn_save_cart_content'][] = array ('function' => 'fn_giftcert_save_cart_content', 'params' => array('cart', 'user_id', 'type'));
$fn_inheritance['fn_extract_cart_content'][] = array ('function' => 'fn_giftcert_extract_cart_content', 'params' => array('cart', 'user_id', 'type'));
$fn_inheritance['fn_get_cart_ontent_item_types'][] = array ('function' => 'fn_giftcert_get_cart_content_item_types', 'params' => array('item_types','action'));
$fn_inheritance['fn_place_order'][] = array ('function' => 'fn_giftcert_place_order', 'params' => array('cart', 'auth', 'order_id'));
$fn_inheritance['fn_get_order_info'][] = array ('function' => 'fn_giftcert_get_order_info', 'params' => array('order'));
$fn_inheritance['fn_get_cart_content_item_types'][] = array ('function' => 'fn_giftcert_get_cart_content_item_types', 'params' => array('item_types', 'action'));
$fn_inheritance['fn_calculate_cart_content'][] = array ('function' => 'fn_giftcert_calculate_cart_content', 'params' => array('cart', 'cart_products', 'shipping_rates', 'auth', 'calculate_shipping', 'calculate_taxes', 'options_style', 'get_global_discount'), 'priority' => 200);
$fn_inheritance['fn_change_order_status'][] = array ('function' => 'fn_giftcert_change_order_status', 'params' => array('status_to', 'status_from', 'notify_user', 'order_info', 'order_statuses'));
$fn_inheritance['fn_order_placement_routines'][] = array ('function' => 'fn_giftcert_order_placement_routines', 'params' => array('order_id', 'notify_user', 'order_info'));
$fn_inheritance['fn_cart_is_empty'][] = array ('function' => 'fn_giftcert_cart_is_empty', 'params' => array('result', 'cart'));
$fn_inheritance['fn_delete_order'][] = array ('function' => 'fn_giftcert_delete_order', 'params' => array('order_id'));
$fn_inheritance['fn_delete_cart_product'][] = array ('function' => 'fn_giftcert_delete_cart_product', 'params' => array('cart', 'cart_id'));
$fn_inheritance['fn_add_exclude_products'][] = array ('function' => 'fn_add_giftcert_exclude_products', 'params' => array('cart', 'auth', 'pure_subtotal', 'subtotal'), 'priority' => 100);
$fn_inheritance['fn_exclude_from_shipping_calculate'][] = array ('function' => 'fn_giftcert_exclude_from_shipping_calculate', 'params' => array('product', 'exclude'));
$fn_inheritance['fn_form_cart'][] = array ('function' => 'fn_form_gift_cert_cart', 'params' => array('order_info', 'cart'));
$fn_inheritance['fn_allow_place_order'][] = array ('function' => 'fn_gift_allow_place_order', 'params' => array('result', 'cart', 'ship_ok'));
//
// Integrate with Promotions
//
define('ACTION_FREE_GIFT_CERTIFICATE', 'G');
$fn_inheritance['fn_prepare_promotion_field'][] = array ('function' => 'fn_prepare_promotion_gift_certificate_field', 'params' => array('entity', 'type', 'value', 'data'));
$fn_inheritance['fn_get_promotion_actions_for_select'][] = array ('function' => 'fn_get_promotion_giftcert_actions_for_select', 'params' => array('actions'));
$fn_inheritance['fn_set_promotion_remain_actions'][] = array ('function' => 'fn_set_promotion_giftcert_actions', 'params' => array('actions', 'promotion_id', 'cart', 'auth', 'params'));

?>