<?php
/******************************************************************************
*                                                                             *
*           Copyright (c) 2004-2007 CS-Cart.com. All rights reserved.         *
*                                                                             *
*******************************************************************************
*                                                                             *
* CS-Cart  is  commercial  software,  only  users  who have purchased a valid *
* license through  http://www.cs-cart.com/  and  accept  to the terms of this *
* License Agreement can install this product.                                 *
*                                                                             *
*******************************************************************************
* THIS  CS-CART  SHOP END-USER LICENSE AGREEMENT IS A LEGAL AGREEMENT BETWEEN *
* YOU  AND  YOUR  COMPANY  (COLLECTIVELY, "YOU") AND CS-CART.COM (HEREINAFTER *
* REFERRED  TO  AS  "THE AUTHOR")  FOR THE SOFTWARE PRODUCT IDENTIFIED ABOVE, *
* WHICH INCLUDES COMPUTER  SOFTWARE AND MAY INCLUDE ASSOCIATED MEDIA, PRINTED *
* MATERIALS,  AND  "ONLINE"  OR  ELECTRONIC  DOCUMENTATION (COLLECTIVELY, THE *
* "SOFTWARE").  BY  USING  THE  SOFTWARE,  YOU  SIGNIFY YOUR AGREEMENT TO ALL *
* TERMS, CONDITIONS, AND NOTICES CONTAINED  OR  REFERENCED HEREIN. IF YOU ARE *
* NOT  WILLING  TO  BE  BOUND  BY  THIS  AGREEMENT, DO NOT INSTALL OR USE THE *
* SOFTWARE.                                                                   *
*                                                                             *
* PLEASE READ THE FULL  TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" *
* FILE PROVIDED WITH THIS  DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE *
* AT THE FOLLOWING URL: http://www.cs-cart.com/license.html                   *
******************************************************************************/


if ( !defined('IN_CSCART') ) { die('Access denied'); }

//
// Database tables aliases...
//
$db_tables['listmania_list_types'] = 'cscart_listmania_list_types';
$db_tables['listmania_list_type_descriptions'] = 'cscart_listmania_list_type_descriptions';
$db_tables['listmania_lists'] = 'cscart_listmania_lists';
$db_tables['listmania_list_objects'] = 'cscart_listmania_list_objects';

//
// Script targets
//
$script_targets['listmania'] = ADDONS_DIR . 'listmania' .DS. 'targets' .DS. 'listmania.php';

//
// Define constants
//
// Pages (home, cart, checkout, ...) have not got ID. Page ID is defined as a constant.
define('COMMON_PAGES_ID', 1);

// object
define('LM_PRODUCT', 1001);
define('LM_CATEGORY', 1002);
define('LM_TOPIC', 1003);
define('LM_PAGE', 1004);
define('LM_NEWS', 1005);
define('LM_HOME_PAGE', 1006);
define('LM_CART_PAGE', 1007);
define('LM_CHECKOUT', 1008);
define('LM_ALL_PAGES', 1009);
// list object
define('LM_ADS', 2001);
//type
define('LM_MANUALLY_SET', 3001);
define('LM_DATE_CREATED', 3002);
define('LM_BESTSELLERS', 3003);
define('LM_ALSO_BOUGHT', 3004);
define('LM_POPULARITY', 3005);
define('LM_RATIG', 3006);
define('LM_IMPULSE_BUYING', 3007);
// appearance box
define('LM_LEFT_SIDEBOX', 4001);
define('LM_CENTRAL', 4002);
define('LM_RIGHT_SIDEBOX', 4003);
define('LM_PRODUCT_DETAILS', 4004);
// appearance order
define('LM_BEFORE_MAIN_CONTENT', 5001);
define('LM_AFTER_MAIN_CONTENT', 5002);
// appearance type
define('LM_TEXT_LINKS', 6001);
define('LM_LINKS_THUMB', 6002);
define('LM_MULTICOLUMNS', 6003);
define('LM_MULTICOLUMNS_SMALL', 6004);
define('LM_SCROLLER', 6005);
define('LM_ORIGINAL', 6006);
define('LM_PRODUCTS', 6007);
define('LM_SIDEBOX_1_ITEM', 6008);
define('LM_SMALL_ITEMS', 6009);
define('LM_WITHOUT_IMAGE', 6010);
define('LM_SCROLLER2', 6011);
define('LM_SCROLLER3', 6012);
define('LM_PRODUCTS2', 6013);
// data permissions 
//define('LM_ANY', 7001);
// date periods for "date created" list type
define('LM_ANY_DATE', 8001);
define('LM_TODAY', 8002);
define('LM_LAST_N_DAYS', 8003);
// scroller direction
define('LM_TO_DOWN', '9001');
define('LM_TO_UP', '9002');
define('LM_TO_RIGHT', '9003');
define('LM_TO_LEFT', '9004');

define('LM_NOT_APPLICABLE', '0');
//
// /Define constants
//

$fn_inheritance['fn_delete_product'][] = array ('function' => 'fn_lm_delete_object', 'params' => array('product_id'), 'static' => array(LM_PRODUCT));
$fn_inheritance['fn_delete_category'][] = array ('function' => 'fn_lm_delete_object', 'params' => array('category_id'), 'static' => array(LM_CATEGORY));
$fn_inheritance['fn_delete_topic'][] = array ('function' => 'fn_lm_delete_object', 'params' => array('topic_ids'), 'static' => array(LM_TOPIC));
$fn_inheritance['fn_delete_page'][] = array ('function' => 'fn_lm_delete_object', 'params' => array('page_inner_id'), 'static' => array(LM_PAGE));
$fn_inheritance['fn_delete_news'][] = array ('function' => 'fn_lm_delete_object', 'params' => array('news_id'), 'static' => array(LM_NEWS));
$fn_inheritance['fn_clone_product'][] = array ('function' => 'fn_lm_clone_lists', 'params' => array('product_id', 'pid'), 'static' => array(LM_PRODUCT));

//
// Define base arrays
//
$lm_object = array();
$lm_object[LM_PRODUCT] = 'product';
$lm_object[LM_CATEGORY] = 'category';
$lm_object[LM_TOPIC] = 'topic';
$lm_object[LM_PAGE] = 'page';
$lm_object[LM_NEWS] = 'news';
$lm_object[LM_HOME_PAGE] = 'home_page';
$lm_object[LM_CART_PAGE] = 'cart_page';
$lm_object[LM_CHECKOUT] = 'checkout';
$lm_object[LM_ALL_PAGES] = 'all_pages';

$lm_list_object = array();
$lm_list_object[LM_PRODUCT] = 'products';
$lm_list_object[LM_CATEGORY] = 'categories';
$lm_list_object[LM_TOPIC] = 'topics';
$lm_list_object[LM_PAGE] = 'pages';
$lm_list_object[LM_ADS] = 'ads';

$lm_type = array();
$lm_type[LM_MANUALLY_SET] = 'manually_set';
$lm_type[LM_DATE_CREATED] = 'newest';
$lm_type[LM_BESTSELLERS] = 'bestsellers';
$lm_type[LM_ALSO_BOUGHT] = 'also_bought';
//$lm_type[LM_POPULARITY] = 'popularity';
$lm_type[LM_RATIG] = 'rating';
//$lm_type[LM_IMPULSE_BUYING] = 'impulse_buying';

$lm_appearance = array();
$lm_appearance['box'] = array();
$lm_appearance['box'][LM_LEFT_SIDEBOX] = 'left_sidebox';
$lm_appearance['box'][LM_CENTRAL] = 'central';
$lm_appearance['box'][LM_PRODUCT_DETAILS] = 'product_details_page';
$lm_appearance['box'][LM_RIGHT_SIDEBOX] = 'right_sidebox';

$lm_appearance['order'] = array();
$lm_appearance['order'][LM_NOT_APPLICABLE] = 'not_applicable';
$lm_appearance['order'][LM_BEFORE_MAIN_CONTENT] = 'before_main_content';
$lm_appearance['order'][LM_AFTER_MAIN_CONTENT] = 'after_main_content';


$lm_appearance['type'] = array();
$lm_appearance['type'][LM_TEXT_LINKS] = 'text_links';
$lm_appearance['type'][LM_LINKS_THUMB] = 'links_thumb';
$lm_appearance['type'][LM_MULTICOLUMNS] = 'multicolumns';
$lm_appearance['type'][LM_MULTICOLUMNS_SMALL] = 'multicolumns_small';
$lm_appearance['type'][LM_ORIGINAL] = 'original';
$lm_appearance['type'][LM_PRODUCTS] = 'products';
$lm_appearance['type'][LM_SIDEBOX_1_ITEM] = 'sidebox_1_item';
$lm_appearance['type'][LM_SMALL_ITEMS] = 'small_items';
$lm_appearance['type'][LM_WITHOUT_IMAGE] = 'without_image';
$lm_appearance['type'][LM_SCROLLER] = 'scroller';
$lm_appearance['type'][LM_SCROLLER2] = 'scroller2';
$lm_appearance['type'][LM_SCROLLER3] = 'scroller3';
$lm_appearance['type'][LM_PRODUCTS2] = 'products2';

$lm_scroller_directions = array();
$lm_scroller_directions[LM_TO_DOWN] = 'down';
$lm_scroller_directions[LM_TO_UP] = 'up';
//$lm_scroller_directions[LM_TO_RIGHT] = 'to_right';
//$lm_scroller_directions[LM_TO_LEFT] = 'to_left';

$lm_listboxes = array();
$lm_slaves = array();
$lm_masters = array();

$listmania_data = array('object' => &$lm_object, 'list_object' => &$lm_list_object, 'type' => &$lm_type, 'appearance' => &$lm_appearance, 'sideboxes' => &$lm_listboxes, 'scroller_directions' => &$lm_scroller_directions, 'slaves' => &$lm_slaves, 'masters' => &$lm_masters);

if (AREA == 'A' && !empty($target) && $target == 'listmania') {
	// define permited combinations
	
	$lm_slaves['object'] = array();
	
	$lm_slaves['list_object'] = array();
	$_objects = array_keys($lm_object);
	foreach ($lm_list_object as $k => $v) {
		$lm_slaves['list_object'][$k] = array();
		foreach ($_objects as $vv) {
			$lm_slaves['list_object'][$k][] = array('object' => $vv);
		}
	}
	
	$lm_slaves['type'] = array();
	$_objects = array_keys($lm_object);
	$_list_objects = array_keys($lm_list_object);
	foreach ($lm_type as $k => $v) {
		if ($k == LM_IMPULSE_BUYING) {
			$lm_slaves['type'][$k] = array(array('object' => LM_PRODUCT, 'list_object' => LM_PRODUCT));
		} elseif ($k == LM_ALSO_BOUGHT) {
			$lm_slaves['type'][$k] = array(
				array('object' => LM_PRODUCT, 'list_object' => LM_PRODUCT),
				array('object' => LM_CART_PAGE, 'list_object' => LM_PRODUCT),
				array('object' => LM_CHECKOUT, 'list_object' => LM_PRODUCT));
		} elseif ($k == LM_BESTSELLERS) {
			$lm_slaves['type'][$k] = array();
			foreach ($_objects as $obj_vv) {
				$lm_slaves['type'][$k][] = array('object' => $obj_vv, 'list_object' => LM_PRODUCT);
			}
		} else {
			$lm_slaves['type'][$k] = array();
			foreach ($_objects as $obj_vv) {
				foreach ($_list_objects as $lobj_vv) {
					if ($k != LM_RATIG || $lobj_vv != LM_ADS) {
						$lm_slaves['type'][$k][] = array('object' => $obj_vv, 'list_object' => $lobj_vv);
					}
				}
			}
		}
	}
	
	$lm_slaves['appearance_box'] = array();
	$_objects = array_keys($lm_object);
	foreach ($lm_appearance['box'] as $k => $v) {
		if ($k == LM_PRODUCT_DETAILS) {
			$lm_slaves['appearance_box'][$k] = array(array('object' => LM_PRODUCT));
		} else {
			$lm_slaves['appearance_box'][$k] = array();
			foreach ($_objects as $vv) {
				$lm_slaves['appearance_box'][$k][] = array('object' => $vv);
			}
		}
	}
	
	$lm_slaves['appearance_order'] = array();
	$_appearance_boxes = array_keys($lm_appearance['box']);
	foreach ($lm_appearance['order'] as $k => $v) {
		$lm_slaves['appearance_order'][$k] = array();
		if ($k == LM_NOT_APPLICABLE) {
			$lm_slaves['appearance_order'][$k][] = array('appearance_box' => LM_PRODUCT_DETAILS);
		} else {
			foreach ($_appearance_boxes as $vv) {
				if ($vv != LM_PRODUCT_DETAILS) {
					$lm_slaves['appearance_order'][$k][] = array('appearance_box' => $vv);
				}
			}
		}
	}
	
	$lm_slaves['appearance_type'] = array();
	$_list_objects = array_keys($lm_list_object);
	$_appearance_boxes = array_keys($lm_appearance['box']);
	foreach ($lm_appearance['type'] as $k => $v) {
		if ($k == LM_TEXT_LINKS) {
			$lm_slaves['appearance_type'][$k] = array();
			foreach ($_list_objects as $vv) {
				if ($vv != LM_ADS) {
					foreach ($_appearance_boxes as $vvv) {
						if ($vvv != LM_PRODUCT_DETAILS || $vv == LM_PRODUCT) {
							$lm_slaves['appearance_type'][$k][] = array('list_object' => $vv, 'appearance_box' => $vvv);
						}
					}
				}
			}
		} elseif ($k == LM_ORIGINAL) {
			$lm_slaves['appearance_type'][$k] = array(
				array('list_object' => LM_ADS, 'appearance_box' => LM_LEFT_SIDEBOX),
				array('list_object' => LM_ADS, 'appearance_box' => LM_CENTRAL),
				array('list_object' => LM_ADS, 'appearance_box' => LM_PRODUCT_DETAILS),
				array('list_object' => LM_ADS, 'appearance_box' => LM_RIGHT_SIDEBOX));
		} elseif ($k == LM_MULTICOLUMNS) {
			$lm_slaves['appearance_type'][$k] = array(
				array('list_object' => LM_PRODUCT, 'appearance_box' => LM_CENTRAL),
				array('list_object' => LM_PRODUCT, 'appearance_box' => LM_PRODUCT_DETAILS),
				array('list_object' => LM_CATEGORY, 'appearance_box' => LM_CENTRAL));
		} elseif ($k == LM_MULTICOLUMNS_SMALL || $k == LM_PRODUCTS || $k == LM_PRODUCTS2) {
			$lm_slaves['appearance_type'][$k] = array(
				array('list_object' => LM_PRODUCT, 'appearance_box' => LM_CENTRAL),
				array('list_object' => LM_PRODUCT, 'appearance_box' => LM_PRODUCT_DETAILS));
		} else {  //LM_LINKS_THUMB, LM_SIDEBOX_1_ITEM, LM_SMALL_ITEMS, LM_WITHOUT_IMAGE, LM_SCROLLER, LM_SCROLLER2, LM_SCROLLER3
			$lm_slaves['appearance_type'][$k] = array(
				array('list_object' => LM_PRODUCT, 'appearance_box' => LM_LEFT_SIDEBOX),
				array('list_object' => LM_PRODUCT, 'appearance_box' => LM_RIGHT_SIDEBOX));
		}
	}
	
	foreach ($lm_slaves as $slave => $v) {
		foreach ($v as $slave_value => $vv) {
			foreach ($vv as $vvv) {
				foreach ($vvv as $master => $master_value) {
					if ($slave_value == LM_NOT_APPLICABLE) {
						$_title = LM_NOT_APPLICABLE;
					} else {
						if (strpos($slave, 'appearance') !== false) {
							$_appearance = substr($slave, strpos($slave, '_') + 1);
							$_title = $listmania_data['appearance'][$_appearance][$slave_value];
						} else {
							$_title = $listmania_data[$slave][$slave_value];
						}
					}
					$lm_masters[$master][$master_value][$slave][$slave_value] = $_title;
				}
			}
		}
	}
}

//
// /Define based arrays
//
?>