<?php
/******************************************************************************
*                                                                             *
*           Copyright (c) 2004-2007 CS-Cart.com. All rights reserved.         *
*                                                                             *
*******************************************************************************
*                                                                             *
* CS-Cart  is  commercial  software,  only  users  who have purchased a valid *
* license through  http://www.cs-cart.com/  and  accept  to the terms of this *
* License Agreement can install this product.                                 *
*                                                                             *
*******************************************************************************
* THIS  CS-CART  SHOP END-USER LICENSE AGREEMENT IS A LEGAL AGREEMENT BETWEEN *
* YOU  AND  YOUR  COMPANY  (COLLECTIVELY, "YOU") AND CS-CART.COM (HEREINAFTER *
* REFERRED  TO  AS  "THE AUTHOR")  FOR THE SOFTWARE PRODUCT IDENTIFIED ABOVE, *
* WHICH INCLUDES COMPUTER  SOFTWARE AND MAY INCLUDE ASSOCIATED MEDIA, PRINTED *
* MATERIALS,  AND  "ONLINE"  OR  ELECTRONIC  DOCUMENTATION (COLLECTIVELY, THE *
* "SOFTWARE").  BY  USING  THE  SOFTWARE,  YOU  SIGNIFY YOUR AGREEMENT TO ALL *
* TERMS, CONDITIONS, AND NOTICES CONTAINED  OR  REFERENCED HEREIN. IF YOU ARE *
* NOT  WILLING  TO  BE  BOUND  BY  THIS  AGREEMENT, DO NOT INSTALL OR USE THE *
* SOFTWARE.                                                                   *
*                                                                             *
* PLEASE READ THE FULL  TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" *
* FILE PROVIDED WITH THIS  DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE *
* AT THE FOLLOWING URL: http://www.cs-cart.com/license.html                   *
******************************************************************************/


if ( !defined('IN_CSCART') ) { die('Access denied'); }

//
// Database tables aliases...
//
$db_tables['lh_country_codes'] = 'cscart_lh_country_codes';
$db_tables['lh_ip_to_country'] = 'cscart_lh_ip_to_country';
$db_tables['lh_left_messages'] = 'cscart_lh_left_messages';
$db_tables['lh_messages'] = 'cscart_lh_messages';
$db_tables['lh_messages_map'] = 'cscart_lh_messages_map';
$db_tables['lh_operators'] = 'cscart_lh_operators';
$db_tables['lh_sessions'] = 'cscart_lh_sessions';
$db_tables['lh_type_notify'] = 'cscart_lh_type_notify';
$db_tables['lh_visitors'] = 'cscart_lh_visitors';
$db_tables['lh_visitors_log'] = 'cscart_lh_visitors_log';
$db_tables['lh_visitors_notes'] = 'cscart_lh_visitors_notes';

//
// Script targets
//
$script_targets['lh_visitor'] = ADDONS_DIR . 'live_help' .DS. 'targets' .DS. 'visitor.php';
$script_targets['lh_operator'] = ADDONS_DIR . 'live_help' .DS. 'targets' .DS. 'operator.php';
$script_targets['lh_chat'] = ADDONS_DIR . 'live_help' .DS. 'targets' .DS. 'chat.php';

$script_targets['lh_manage_operators'] = ADDONS_DIR . 'live_help' .DS. 'targets' .DS. 'manage_operators.php';
$script_targets['lh_history'] = ADDONS_DIR . 'live_help' .DS. 'targets' .DS. 'history.php';
$script_targets['lh_reports'] = ADDONS_DIR . 'live_help' .DS. 'targets' .DS. 'reports.php';

//
// Static configuration
//
$addon_config['freshness_time'] = 5;
$addon_config['freshness_time_visitor'] = 6;
$addon_config['chat_interval'] = 3000;
$addon_config['obsolete_time'] = 3;
$addon_config['visitor_data_clean_period'] = 86400;

array_push($secure_targets, 'lh_visitor', 'lh_chat', 'lh_operator');

//
// Directories
//
$var_dir['lh_uploads'] = CSCART_DIR .DS. 'var' .DS. 'lh_uploads';


//
// Constants
//

// Visitor status
define('LH_STATUS_IDLE', 0);
define('LH_STATUS_WAITING', 1);
define('LH_STATUS_CHATTING', 2);
define('LH_STATUS_REQUEST_SENT', 3);
define('LH_STATUS_DECLINED', 4);

// Message directions
define('LH_DIRECTION_VISITOR_OPERATOR', 0);
define('LH_DIRECTION_OPERATOR_VISITOR', 1);
define('LH_DIRECTION_OPERATOR_OPERATOR', 2);

// Last messages map directions
define('LH_DIRECTION_MAP_SESSIONS', 0);
define('LH_DIRECTION_MAP_OPERATORS', 1);

// Typing notifications
define('LH_TYPING_ON', 1);
define('LH_TYPING_OFF', -1);

// Visitor logging events
define('LH_LOG_CHAT_STARTED', 1);
define('LH_LOG_OPERATOR_JOINED', 2);
define('LH_LOG_SENT_INVITATION', 3);
define('LH_LOG_ACCEPTED_INVITATION', 4);
define('LH_LOG_DECLINED_INVITATION', 5);

// OS indexes
define('LH_OS_WINDOWS', 1);
define('LH_OS_LINUX', 2);
define('LH_OS_MAC', 3);
define('LH_OS_OTHER', 0);


$os_list = array(
	'Windows' => LH_OS_WINDOWS, 
	'Linux' => LH_OS_LINUX, 
	'Mac' => LH_OS_MAC,
);

//
// Other
//

// Overwriting users online counter
if (AREA == 'A') {
	$users_online = db_get_field("SELECT COUNT(*) FROM $db_tables[lh_visitors] WHERE '" . TIME . "' <= obsolete_time");
}
?>