<?php
/******************************************************************************
*                                                                             *
*           Copyright (c) 2004-2007 CS-Cart.com. All rights reserved.         *
*                                                                             *
*******************************************************************************
*                                                                             *
* CS-Cart  is  commercial  software,  only  users  who have purchased a valid *
* license through  http://www.cs-cart.com/  and  accept  to the terms of this *
* License Agreement can install this product.                                 *
*                                                                             *
*******************************************************************************
* THIS  CS-CART  SHOP END-USER LICENSE AGREEMENT IS A LEGAL AGREEMENT BETWEEN *
* YOU  AND  YOUR  COMPANY  (COLLECTIVELY, "YOU") AND CS-CART.COM (HEREINAFTER *
* REFERRED  TO  AS  "THE AUTHOR")  FOR THE SOFTWARE PRODUCT IDENTIFIED ABOVE, *
* WHICH INCLUDES COMPUTER  SOFTWARE AND MAY INCLUDE ASSOCIATED MEDIA, PRINTED *
* MATERIALS,  AND  "ONLINE"  OR  ELECTRONIC  DOCUMENTATION (COLLECTIVELY, THE *
* "SOFTWARE").  BY  USING  THE  SOFTWARE,  YOU  SIGNIFY YOUR AGREEMENT TO ALL *
* TERMS, CONDITIONS, AND NOTICES CONTAINED  OR  REFERENCED HEREIN. IF YOU ARE *
* NOT  WILLING  TO  BE  BOUND  BY  THIS  AGREEMENT, DO NOT INSTALL OR USE THE *
* SOFTWARE.                                                                   *
*                                                                             *
* PLEASE READ THE FULL  TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" *
* FILE PROVIDED WITH THIS  DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE *
* AT THE FOLLOWING URL: http://www.cs-cart.com/license.html                   *
******************************************************************************/

//
// $Id: config.php,v 1.1.1.1 2007/12/13 10:08:01 pshevtsov Exp $
//

if ( !defined('IN_CSCART') ) { die('Access denied'); }

//
// Database tables aliases...
//
$db_tables['promotions'] = 'cscart_promotions';
$db_tables['promotion_descriptions'] = 'cscart_promotion_descriptions';
$db_tables['promotion_conditions'] = 'cscart_promotion_conditions';
$db_tables['promotion_condition_descriptions'] = 'cscart_promotion_condition_descriptions';
$db_tables['promotion_actions'] = 'cscart_promotion_actions';
$db_tables['promotion_condition_rules'] = 'cscart_promotion_condition_rules';


//
// Defined variables
//
define('ORDER_DATA_PROMOTION', 'R');

define('ACTION', 'A');
define('CONDITION', 'C');

define('CONDITION_SPENT_MONEY', 'S');
define('CONDITION_NUMBER_OF_PRODUCTS_EXCEEDS', 'A');
define('CONDITION_NECESSARY_MEMBERSHIPS', 'M');
define('CONDITION_PERIOD_OF_VALIDITY', 'V');
define('CONDITION_PURCHASED_PRODUCTS', 'P');

define('ACTION_DISCOUNT_ON_ORDER', 'I');
define('ACTION_DISCOUNT_ON_PRODUCTS', 'D');
define('ACTION_FREE_PRODUCTS', 'F');

define('ANY_OPTION_COMBINATIONS', 'AOC');
define('PROMOTION_EXCLUDE_PRODUCTS', 'PR');

//
// Script targets
//
$script_targets['promotions'] = ADDONS_DIR . 'promotions' .DS. 'targets' .DS. 'promotions.php';

$fn_inheritance['fn_calculate_cart_content'][] = array ('function' => 'fn_promotion_calculate_cart_content', 'params' => array('cart', 'cart_products', 'auth', 'calculate_shipping', 'calculate_taxes', 'options_style', 'get_global_discount'), 'priority' => 0);
$fn_inheritance['fn_place_order'][] = array ('function' => 'fn_promotion_place_order', 'params' => array('cart', 'order_id'));
$fn_inheritance['fn_get_order_info'][] = array ('function' => 'fn_promotion_get_order_info', 'params' => array('order', 'additional_data'));
$fn_inheritance['fn_get_product_discount'][] = array ('function' => 'fn_get_promotion_product_discount', 'params' => array('product_id', 'discount', 'cart'));
$fn_inheritance['fn_delete_product'][] = array ('function' => 'fn_delete_promotion_product', 'params' => array('product_id'));
$fn_inheritance['fn_delete_product_option'][] = array ('function' => 'fn_delete_promotion_product_option', 'params' => array('option_id', 'pid'));
$fn_inheritance['fn_add_exclude_products'][] = array ('function' => 'fn_add_promotion_exclude_products', 'params' => array('cart', 'auth', 'pure_subtotal', 'subtotal', 'choosable_product_options'), 'priority' => 200);
$fn_inheritance['fn_calculate_global_discount'][] = array ('function' => 'fn_get_promotion_discount_on_order', 'params' => array('cart', 'discounts'));
$fn_inheritance['fn_set_shipping_discounts'][] = array ('function' => 'fn_set_promotion_free_shipping', 'params' => array('cart', 'result'));
$fn_inheritance['fn_gather_products_with_choosable_options'][] = array ('function' => 'fn_gather_promotion_free_products_with_choosable_options', 'params' => array('product', 'choosable_product_options'));
$fn_inheritance['fn_generate_cart_id'][] = array ('function' => 'fn_generate_promotion_cart_id', 'params' => array('_cid', 'extra'));
?>