<?php
/******************************************************************************
*                                                                             *
*           Copyright (c) 2004-2007 CS-Cart.com. All rights reserved.         *
*                                                                             *
*******************************************************************************
*                                                                             *
* CS-Cart  is  commercial  software,  only  users  who have purchased a valid *
* license through  http://www.cs-cart.com/  and  accept  to the terms of this *
* License Agreement can install this product.                                 *
*                                                                             *
*******************************************************************************
* THIS  CS-CART  SHOP END-USER LICENSE AGREEMENT IS A LEGAL AGREEMENT BETWEEN *
* YOU  AND  YOUR  COMPANY  (COLLECTIVELY, "YOU") AND CS-CART.COM (HEREINAFTER *
* REFERRED  TO  AS  "THE AUTHOR")  FOR THE SOFTWARE PRODUCT IDENTIFIED ABOVE, *
* WHICH INCLUDES COMPUTER  SOFTWARE AND MAY INCLUDE ASSOCIATED MEDIA, PRINTED *
* MATERIALS,  AND  "ONLINE"  OR  ELECTRONIC  DOCUMENTATION (COLLECTIVELY, THE *
* "SOFTWARE").  BY  USING  THE  SOFTWARE,  YOU  SIGNIFY YOUR AGREEMENT TO ALL *
* TERMS, CONDITIONS, AND NOTICES CONTAINED  OR  REFERENCED HEREIN. IF YOU ARE *
* NOT  WILLING  TO  BE  BOUND  BY  THIS  AGREEMENT, DO NOT INSTALL OR USE THE *
* SOFTWARE.                                                                   *
*                                                                             *
* PLEASE READ THE FULL  TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" *
* FILE PROVIDED WITH THIS  DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE *
* AT THE FOLLOWING URL: http://www.cs-cart.com/license.html                   *
******************************************************************************/

//
// $Id: config.php,v 1.1.1.1 2007/12/13 10:08:00 pshevtsov Exp $
//

if ( !defined('IN_CSCART') ) { die('Access denied'); }

//
// Database tables aliases...
//

$db_tables['reward_points'] = 'cscart_reward_points';
$db_tables['reward_point_changes'] = 'cscart_reward_point_changes';
$db_tables['product_point_prices'] = 'cscart_product_point_prices';


//
// Defined variables
//

define('ORDER_DATA_POINTS_GAIN','G');

define('PRODUCT_REWARD_POINTS','P');
define('CATEGORY_REWARD_POINTS','C');
define('GLOBAL_REWARD_POINTS','G');

define('POINTS','W');
define('POINTS_MODIFIER_TYPE','R');
define('POINTS_IN_USE','I');

//
//These constants define the reason for the change of points
//
define('CHANGE_DUE_ORDER','O');
define('CHANGE_DUE_USE','I');
define('CHANGE_DUE_RMA','R');
define('CHANGE_DUE_ADDITION','A');
define('CHANGE_DUE_SUBTRACT','S');

//
// Script targets
//
$script_targets['reward_points'] = ADDONS_DIR . 'reward_points' .DS. 'targets' .DS. 'reward_points.php';




$fn_inheritance['fn_get_cart_product_data'][] = array ('function' => 'fn_get_cart_product_points_data', 'params' => array('product_id', '_pdata'));
$fn_inheritance['fn_gather_additional_product_data'][] = array ('function' => 'fn_calculate_product_reward_points', 'params' => array('product', 'auth', 'get_options'));
$fn_inheritance['fn_gather_additional_product_data'][] = array ('function' => 'fn_calculate_product_price_in_points', 'params' => array('product', 'auth', 'get_options'));
$fn_inheritance['fn_calculate_cart_content'][] = array ('function' => 'fn_calculate_points_cart_content', 'params' => array('cart', 'cart_products', 'auth','get_global_discount'), 'priority' => 300);
$fn_inheritance['fn_place_order'][] = array ('function' => 'fn_place_order_points', 'params' => array('cart', 'auth', 'order_id'));
$fn_inheritance['fn_get_order_info'][] = array ('function' => 'fn_get_order_points_info', 'params' => array('order', 'additional_data'));
$fn_inheritance['fn_change_order_status'][] = array ('function' => 'fn_change_order_points_status', 'params' => array('status_to', 'status_from', 'order_info', 'order_statuses'));
$fn_inheritance['fn_get_user_info'][] = array ('function' => 'get_user_points_info', 'params' => array('user_data'));
$fn_inheritance['fn_get_product_options'][] = array ('function' => 'fn_get_product_points_options', 'params' => array('extra_variant_fields'));
$fn_inheritance['fn_get_selected_product_options'][] = array ('function' => 'fn_get_product_points_options', 'params' => array('extra_variant_fields'));
$fn_inheritance['fn_apply_options_modifiers'][] = array ('function' => 'fn_apply_options_points_modifiers', 'params' => array('fields', 'type'));
$fn_inheritance['fn_clone_product'][] = array ('function' => 'fn_clone_product_points_info', 'params' => array('product_id', 'pid'));
$fn_inheritance['fn_external_discounts'][] = array ('function' => 'fn_external_point_discounts', 'params' => array('product', 'discounts'));
$fn_inheritance['fn_form_cart'][] = array ('function' => 'fn_form_cart_points', 'params' => array('order_info', 'cart'));
$fn_inheritance['fn_allow_place_order'][] = array ('function' => 'fn_point_allow_place_order', 'params' => array('result', 'cart', 'ship_ok'));

//
// Integrate with Promotions
//
define('ACTION_FREE_POINTS', 'W');
define('CONDITION_USER_POINTS', 'U');

$fn_inheritance['fn_get_promotion_actions_for_select'][] = array ('function' => 'fn_get_promotion_point_actions_for_select', 'params' => array('actions'));
$fn_inheritance['fn_get_promotion_conditions_for_select'][] = array ('function' => 'fn_get_promotion_point_conditions_for_select', 'params' => array('conditions'));
$fn_inheritance['fn_prepare_promotion_field'][] = array ('function' => 'fn_prepare_promotion_point_field', 'params' => array('entity', 'type', 'value', 'data'));
$fn_inheritance['fn_check_condition'][] = array ('function' => 'fn_check_points_condition', 'params' => array('condition', 'result', 'auth'));
$fn_inheritance['fn_set_promotion_remain_actions'][] = array ('function' => 'fn_set_promotion_points_actions', 'params' => array('actions', 'cart'));


//
//Integrate with RMA
//
$fn_inheritance['fn_rma_recalculate_order_routine'][] = array ('function' => 'fn_recalculate_order_reward_points', 'params' => array('item', 'mirror_item', 'type', 'ex_data', 'amount'));
?>