<?php
/******************************************************************************
*                                                                             *
*           Copyright (c) 2004-2007 CS-Cart.com. All rights reserved.         *
*                                                                             *
*******************************************************************************
*                                                                             *
* CS-Cart  is  commercial  software,  only  users  who have purchased a valid *
* license through  http://www.cs-cart.com/  and  accept  to the terms of this *
* License Agreement can install this product.                                 *
*                                                                             *
*******************************************************************************
* THIS  CS-CART  SHOP END-USER LICENSE AGREEMENT IS A LEGAL AGREEMENT BETWEEN *
* YOU  AND  YOUR  COMPANY  (COLLECTIVELY, "YOU") AND CS-CART.COM (HEREINAFTER *
* REFERRED  TO  AS  "THE AUTHOR")  FOR THE SOFTWARE PRODUCT IDENTIFIED ABOVE, *
* WHICH INCLUDES COMPUTER  SOFTWARE AND MAY INCLUDE ASSOCIATED MEDIA, PRINTED *
* MATERIALS,  AND  "ONLINE"  OR  ELECTRONIC  DOCUMENTATION (COLLECTIVELY, THE *
* "SOFTWARE").  BY  USING  THE  SOFTWARE,  YOU  SIGNIFY YOUR AGREEMENT TO ALL *
* TERMS, CONDITIONS, AND NOTICES CONTAINED  OR  REFERENCED HEREIN. IF YOU ARE *
* NOT  WILLING  TO  BE  BOUND  BY  THIS  AGREEMENT, DO NOT INSTALL OR USE THE *
* SOFTWARE.                                                                   *
*                                                                             *
* PLEASE READ THE FULL  TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" *
* FILE PROVIDED WITH THIS  DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE *
* AT THE FOLLOWING URL: http://www.cs-cart.com/license.html                   *
******************************************************************************/


if ( !defined('IN_CSCART') ) { die('Access denied'); }

//
// Database tables aliases...
//
$db_tables['stat_ips'] = 'cscart_stat_ips';
$db_tables['stat_browsers'] = 'cscart_stat_browsers';
$db_tables['stat_sessions'] = 'cscart_stat_sessions';
$db_tables['stat_requests'] = 'cscart_stat_requests';
$db_tables['stat_robots'] = 'cscart_stat_robots';
$db_tables['stat_search_phrases'] = 'cscart_stat_search_phrases';
$db_tables['stat_search_engines'] = 'cscart_stat_search_engines';
$db_tables['stat_ip2nation'] = 'cscart_stat_ip2nation';
$db_tables['stat_languages'] = 'cscart_stat_languages';
$db_tables['stat_filters'] = 'cscart_stat_filters';
$db_tables['stat_filter_descriptions'] = 'cscart_stat_filter_descriptions';
$db_tables['stat_product_search'] = 'cscart_stat_product_search';

//
// Script targets
//
$script_targets['post_statistics'] = ADDONS_DIR . 'statistics' .DS. 'targets' .DS. 'post_statistics.php';
$script_targets['view_statistics'] = ADDONS_DIR . 'statistics' .DS. 'targets' .DS. 'view_statistics.php';
$script_targets['statistics_filters'] = ADDONS_DIR . 'statistics' .DS. 'targets' .DS. 'statistics_filters.php';


array_push($secure_targets, 'post_statistics');

$fn_inheritance['fn_live_help_get_group_basic_data'][] = array ('function' => 'fn_get_visitor_requests', 'params' => array('group_name', 'result'));

//
// [CONSTANTS]
//
define('STAT_PERIOD_DAY', 1001);
define('STAT_PERIOD_MONTH', 1002);
define('STAT_PERIOD_HOUR', 1003);
// Type of pages statistics
define('STAT_PAGES_BY_VISITS', 'pages_by_visits');
define('STAT_TITLES_BY_VISITS', 'titles_by_visits');
define('STAT_ENTRY_POINTS', 'entry_points');
define('STAT_EXIT_POINTS', 'exit_points');
// Request type
define('STAT_FIRST_REQUEST', 3000);
define('STAT_ORDINARY_REQUEST', 3001);
define('STAT_LAST_REQUEST', 3002);
define('STAT_END_REQUEST', 3003);
// Type of audience statistics
define('STAT_TOTAL_PAGES_VIEWED', 'total_pages_viewed_per_visitor');
define('STAT_VISIT_TIME', 'visit_time');
define('STAT_REPEAT_NEW_VISITS', 'repeat_new_visits');
define('STAT_PAGE_LOAD_SPEED', 'page_load_speed');
define('STAT_SITE_ATTENDANCE', 'site_attendance');
// Type of referrers statistics
define('STAT_ALL_REFERRERS', 'all');
define('STAT_BY_DOMAIN', 'by_domain');
define('STAT_BY_SEARCH_ENGINE', 'by_search_engine');
define('STAT_SEARCH_WORDS', 'search_words');
define('STAT_CAME_TO', 'came_to');
define('STAT_CAME_FROM', 'came_from');
// Condition fields
define('STAT_IP', 4001);
define('STAT_LANGUAGE', 4002);
define('STAT_SEARCH_PHRASE', 4003);
define('STAT_PAGE', 4004);
define('STAT_PAGE_TITLE', 4005);
define('STAT_USER_AGENT', 4007);
define('STAT_BROWSER_NAME', 4008);
define('STAT_OS', 4009);
define('STAT_COUNTRY', 4010);
define('STAT_REFERRER_URL', 4011);
define('STAT_BROWSER_VERSION', 4014);
// Type of system statistics
define('STAT_SYS_OS', 'operating_systems');
define('STAT_SYS_BROWSER', 'browsers');
define('STAT_SYS_RESOLUTION', 'resolutions');
// Type of geography statistics
define('STAT_GEO_COUNTRY', 'countries');
define('STAT_GEO_CITY', 'cities');
define('STAT_GEO_LANGUAGE', 'languages');
define('STAT_GEO_IP', 'ip_addresses');
// Type of product search statistics
define('STAT_PRODUCT_SEARCH_WORDS', 'product_search_words');

// It is limit to load data from DB, when we calculate quantity or row
define('STAT_ROW_LIMIT', 100000); // see using function fn_calc_aggregate_functions

define('ONLINE_TIME', 300); // Time interval during which a customer status is considered online

//
// [/CONSTANTS]
//

$search_engines = array(
	'Yandex' => array(
		'hosts' => 'yandex',
		'qfield' => 'text',
		'charset'=> 'cp1251',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.yandex.ru/'),
	'Rambler' => array(
		'hosts' => 'rambler',
		'qfield' => 'words',
		'charset'=> 'cp1251',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.rambler.ru/'),
	'Google' => array(
		'hosts' => 'www.google',
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.google.com/'),
	'Aport' => array(
		'hosts' => 'aport',
		'qfield' => 'r',
		'charset'=> 'cp1251',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.aport.ru/'),
	'Mail' => array(
		'hosts' => 'mail',
		'key_word' => 'search',
		'qfield' => 'q',
		'charset'=> 'cp1251',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.mail.ru/'),
	'MSN' => array(
		'hosts' => array('search.msn', 'msn.com'),
		'key_word' => 'results',
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.msn.com/'),
	'Live' => array(
		'hosts' => array('search.live', 'live.com'),
		'key_word' => 'results',
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.live.com/'),
	'Yahoo' => array(
		'hosts' => array('yahoo.com', 'search.yahoo'),
		'qfield' => 'p',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.jahoo.com/'),
	'AllTheWeb' => array(
		'hosts' => 'www.alltheweb',
		'qfield' => 'q',
		'url' => 'http://www.alltheweb.com/'),
	'Looksmart' => array(
		'hosts' => array('looksmart.com', 'search.looksmart'),
		'qfield' => 'qt',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.looksmart.com/'),
	'Ask' => array(
		'hosts' => array('askjeeves.com', 'ask.com'),
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.ask.com/'),
	'AOL' => array(
		'hosts' => 'aol.com',
		'qfield' => array('query', 'encquery'),
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.aol.com/'),
	'Lycos' => array(
		'hosts' => 'lycos.com',
		'qfield' => 'query',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.lycos.com/'),
	'AltaVista' => array(
		'hosts' => 'altavista',
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.altavista.com/'),
	'Search' => array(
		'hosts' => 'search.com',
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.search.com/'),
	'Netscape' => array(
		'hosts' => 'netscape.com',
		'qfield' => array('s', 'query'),
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.netscape.com/'),
	'CNN' => array(
		'hosts' => 'cnn.com',
		'qfield' => 'query',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.cnn.com/SEARCH/'),
	'About' => array(
		'hosts' => 'about.com',
		'qfield' => 'terms',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.about.com/fullsearch.htm'),
	'Mamma' => array(
		'hosts' => 'mamma.com',
		'qfield' => 'query',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.mamma.com/'),
	'Gigablast' => array(
		'hosts' => 'gigablast.com',
		'qfield' => 'q',
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.gigablast.com/'),
	'Voila' => array(
		'hosts' => 'voila.fr',
		'qfield' => array('kw', 'rdata'),
		'charset'=> 'unicode',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.voila.fr/'),
	'Virgilio' => array(
		'hosts' => 'alice.it',
		'qfield' => array('qs'),
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.virgilio.it/'),
	'Baidu' => array(
		'hosts' => 'baidu.com',
		'qfield' => array('wd'),
		'charset'=> 'EUC-JP',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.baidu.com/'),
	'Seznam' => array(
		'hosts' => 'seznam.cz',
		'qfield' => array('w'),
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.seznam.cz/'),
	'Najdi' => array(
		'hosts' => 'najdi.si',
		'qfield' => array('q'),
		'charset'=> 'UTF-8',
		'conv_func' => 'fn_str_htmlentities',
		'url' => 'http://www.najdi.si/'),
);

$crawlers = array(
	'abou', 'alta', 'ask', 'asps', 'atomz', 'b2w', 'back', 'blowfish', 'bookmark', 'bot', 'brouser', 
	'eye', 'catch', 'cgi', 'cosmos', 'crawl', 'data', 'download', 'easy', 'email', 'fetch', 'fusion', 
	'generic', 'get', 'go', 'grub', 'gulli', 'hitwise', 'httplib', 'java', 'link', 'load', 'lycos', 
	'net', 'netmind', 'ninj', 'offline', 'page', 'php', 'picker', 'power', 'pro', 'proxy', 'python', 
	'scan', 'scout', 'search', 'seek', 'site', 'slurp', 'spanner', 'spide', 'spider', 'spyder', 'super', 
	'tele', 'tools', 'tracker', 'url', 'web', 'wget', 'www-perl', 'zao', 'zeus');

?>