// $Id: tabs.js,v 1.1.1.1 2007/12/13 10:08:02 pshevtsov Exp $

//
// Tabs object
//
var cscart_tabs = {
	sections: {},		// all groups and sections
	styles: {},			// group's styles
	s_sections: {},		// group's selected_section
	tabs_history: {},	// it is useing for cyclical show section (if one section depends on another)
	redraw_all_sections: {}, // 
	content_id_prefix: 'content_',
	tab_id_prefix: 'tab_',
	block_set_hash: {},	// low level section can forbid a location.hash modification for self parent
	//
	// Add section
	//
	add_section: function (group_name, style, section, separate_form, tab_type)
	{
		// create empty group's sections object
		if (typeof(this.sections[group_name]) == 'undefined') {
			this.sections[group_name] = {};
		}
		// create empty section's object
		if (typeof(this.sections[group_name][section]) == 'undefined') {
			this.sections[group_name][section] = {};
		}
		this.sections[group_name][section].separate_form = separate_form;
		this.sections[group_name][section].tab_type = tab_type;
		// hide tab which has empty content
		this.hide_empty_tab(group_name, section);
		// create tab's content if tab_type is AJAX
		if (tab_type == 'ajax' && !document.getElementById(this.content_id_prefix + section) && document.getElementById('id_tabsbox_content_' + group_name)) {
			var new_node = document.createElement('div');
			new_node.id = this.content_id_prefix + section;
			new_node.innerHTML = '<!--' + this.content_id_prefix + section + '-->';
			document.getElementById('id_tabsbox_content_' + group_name).appendChild(new_node);
		}
		this.styles[group_name] = style;
	},
	//
	// Hide empty tab
	//
	hide_empty_tab: function (group_name, section)
	{
		if ((this.sections[group_name][section].tab_type != 'ajax' && this.sections[group_name][section].tab_type != 'custom') && this.sections[group_name][section].tab_type != 'url' && document.getElementById(this.tab_id_prefix + section) && (!document.getElementById(this.content_id_prefix + section) || document.getElementById(this.content_id_prefix + section).innerHTML.trim() == '' || document.getElementById(this.content_id_prefix + section).innerHTML.trim() == '<!--' + this.content_id_prefix + section + '-->')) {
			document.getElementById(this.tab_id_prefix + section + (this.styles[group_name] == 'section' ? '_base' : '')).style.display = 'none';
		}
	},
	//
	// Set selected section
	//
	set_selected_section: function(group_name, s_section)
	{
		// if s_section don't exist, then replace with first section.
		if (typeof(this.sections[group_name]) == 'undefined' || typeof(this.sections[group_name][s_section]) == 'undefined') {
			s_section = this._first_key(this.sections[group_name]);
		}
		this.s_sections[group_name] = s_section;
	},
	//
	// Change section.
	//
	show_section: function (group_name, s_section, redraw_all)
	{
		var hide_section = this.s_sections[group_name];
		this.set_selected_section(group_name, s_section);
		
		if (this.sections[group_name]) {
			// all group's sections must exist to redraw all
			if (redraw_all) {
				this.redraw_all_sections[group_name] = redraw_all;
			} else if (!this.redraw_all_sections[group_name]) {
				redraw_all = true;
				this.redraw_all_sections[group_name] = redraw_all;
			}
		}
		
		for (var section in this.sections[group_name])
		{
			// show active section
			if (section == this.s_sections[group_name]) {
				if (document.getElementById('product_save_button')) {
					document.getElementById('product_save_button').style.display = (this.sections[group_name][section].separate_form == 'Y') ? 'none' : '';
				}
				// show content
				if (document.getElementById(this.content_id_prefix + section)) {
					document.getElementById(this.content_id_prefix + section).style.display = '';
				}
				// show tab
				this.show_tab[this.styles[group_name]].active(this.styles[group_name], section);
				// replace values of input fields 'selected_section'
				if (document.getElementsByName('selected_section')) {
					elms = document.getElementsByName('selected_section');
					for (var k = 0; k < elms.length; k++) {
						elms[k].value = this.s_sections[group_name];
					}
				}
				if (this.sections[group_name][section].tab_type == 'ajax') {
					// After first show, we replace onclick function in AJAX tab
					var tab = document.getElementById(this.tab_id_prefix + section);
					tab.section_id = section;
					tab.onclick = function (event) {cscart_tabs.show_section(group_name, this.section_id);};
					this.sections[group_name][section].tab_type == 'js_switch';
				}
				
				// set location.hash
				/*if (location.hash && this.block_set_hash[group_name] && this.block_set_hash[group_name][section]) {
					// if hash is existing and child is blocking current section, then hash is equaling child hash.
					var h_group_name = this.block_set_hash[group_name][section];
					var h_section = this.s_sections[h_group_name];
				} else {*/
					var h_group_name = group_name;
					var h_section = section;
				/*}*/
				//location.hash = '#' + h_group_name + '--' + h_section;
				/*if (fn_get_cookie('cscart_tabs_parents['+ group_name +'][group_name]') && fn_get_cookie('cscart_tabs_parents['+ group_name +'][section]')) {
					// if current section have parent, then parent hash is blocked.
					if (typeof(this.block_set_hash[fn_get_cookie('cscart_tabs_parents['+ group_name +'][group_name]')]) == 'undefined') {
						this.block_set_hash[fn_get_cookie('cscart_tabs_parents['+ group_name +'][group_name]')] = {};
					}
					this.block_set_hash[fn_get_cookie('cscart_tabs_parents['+ group_name +'][group_name]')][fn_get_cookie('cscart_tabs_parents['+ group_name +'][section]')] = group_name;
				}*/
				// \set location.hash
				
			} else if (section == hide_section || redraw_all) {
				// Hide section's content
				if (document.getElementById(this.content_id_prefix + section)) {
					document.getElementById(this.content_id_prefix + section).style.display = 'none';
				}
				// Show inactive tab
				this.show_tab[this.styles[group_name]].inactive(this.styles[group_name], section);
			}
		}
		
		if (this.tabs_history[group_name]) {
			// if current group has dependent section, then it show
			var h_section = this.tabs_history[group_name];
			delete this.tabs_history[group_name];
			document.getElementById(this.tab_id_prefix + h_section).onclick();
		}
	},
	//
	// It is tab's display functions for defferent styles.
	//
	show_tab: {
		'general': {
			'active': function(style, section)
			{
				document.getElementById('tab_' + style + '_' + section + '_bg').className = 'section-active-tab-bg';
				document.getElementById('tab_' + style + '_' + section + '_left').src = tab_left_active_image_path;
				document.getElementById('tab_' + style + '_' + section + '_right').src = tab_right_active_image_path;
			},
			'inactive': function(style, section)
			{
				document.getElementById('tab_' + style + '_' + section + '_bg').className = 'section-inactive-tab-bg';
				document.getElementById('tab_' + style + '_' + section + '_left').src = tab_left_image_path;
				document.getElementById('tab_' + style + '_' + section + '_right').src = tab_right_image_path;
			}
		},
		'section': {
			'active': function(style, section)
			{
				document.getElementById('tab_' + section).className = 'bold';
			},
			'inactive': function(style, section)
			{
				document.getElementById('tab_' + section).className = '';
			}
		}
	},
	//
	// Set tab group's parent
	//
	set_parent: function(group_name, parent_group_name, parent_section)
	{
		// We save group's parents in cookie to have it information on any section.
		fn_set_cookie('cscart_tabs_parents[' + group_name + '][group_name]', parent_group_name);
		fn_set_cookie('cscart_tabs_parents[' + group_name + '][section]', parent_section);
	},
	//
	// Check new_group_name and new_section and redirect to neighbouring or parental section.
	//
	set_section: function(cur_group_name, cur_section, new_group_name, new_section)
	{
		if (!new_group_name || !new_section || (new_group_name == cur_group_name && new_section == cur_section) /*|| (this.sections[new_group_name] && this.s_sections[new_group_name] == new_section)*/) {
			return {'group_name': cur_group_name, 'section': cur_section};
		}
		var result = false;
		if (new_group_name != cur_group_name) {
			if (cscart_tabs_parents[new_group_name]) {
				// If new group have got parent group, then switch to parent group.
				if (typeof(this.tabs_history[new_group_name]) == 'undefined') {
					this.tabs_history[new_group_name] = new_section;
					result = this.set_section(cur_group_name, cur_section, cscart_tabs_parents[new_group_name].group_name, cscart_tabs_parents[new_group_name].section);
				} else if (cscart_tabs_parents[new_group_name].group_name == cur_group_name) {
					return {'group_name': cur_group_name, 'section': cscart_tabs_parents[new_group_name].section};
				}
			} else {
				// Show new section in new group
				document.getElementById(this.tab_id_prefix + new_section).onclick();
				this.tabs_history[new_group_name] = new_section;
				// and show current section in current group (need when tab_type = js_switch)
				return {'group_name': cur_group_name, 'section': cur_section};
			}
		} else if (new_section != cur_section) {
			// It shows neighbouring section.
			document.getElementById(this.tab_id_prefix + new_section).onclick();
		}

		if (document.getElementById(this.content_id_prefix + cur_section)) {
			document.getElementById(this.content_id_prefix + cur_section).style.display = 'none';
		}
		return result;
	},
	//
	// Return first object's property
	//
	_first_key: function (obj)
	{
		if (typeof(obj) != 'undefined') {
			for (var key in obj) {
				if (typeof(obj[key]) != 'function') {
					return key;
				}
			}
		}
		return false;
	}
}
