// $Id: template_editor_scripts.js,v 1.1.1.1 2007/12/13 10:08:02 pshevtsov Exp $

var cscart_template_editor = {

	selected_file: '',

	// Refresh directory tree
	refresh: function(data)
	{
		if (data && data.message) {
			this.show_status(data.action_type, data.message);
		}

		fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'=browse', '', '', '', this.show_list.bind(this), false);
	},

	// Change directory in file browser
	chdir: function(dir)
	{
		if (dir.length==0) {
			return;
		}

		fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'=browse&dir='+dir, '', '', '', this.show_list.bind(this), false);
	},

	// Show file content
	show_content: function(file)
	{
		if (!file) {
			file = this.selected_file;
		}
		var te_win = window.open(index_script+'?'+target_name+'=template_editor&'+mode_name+'=edit&file='+file,"te_ed","status=no,top=100,left=100,height=570,width=700,resizable=no");
		te_win.focus();
		
	},
	
	show_list: function(data)
	{
		this.directory_data = data.directory_data;

		document.getElementById('filelist').innerHTML = data.files_list;
		document.getElementById('path').innerHTML = data.current_path;
		document.getElementById('legend').style.display = data.show_legend;

		var exploded_path = data.current_path.split('/');
		var result = '';
		var tmp = '';

		exploded_path = exploded_path.reverse(); // FIXME!!! - very bad code
		if (exploded_path[0] != '') {
			exploded_path.unshift('');
		}
		for (k in exploded_path) {
			if (exploded_path[k] == '') {
				continue;
			}
			if (k != '') {
				tmp = '';
				for (i=0; i<k-1;i++) {
					tmp += '../';
				}
				result = (exploded_path[k] == '[ROOT]' ? '' : '/') + "<a href=\"javascript: cscart_template_editor.chdir('" + tmp + "')\">" + exploded_path[k] + "</a>" + result;
			}
		}
		document.getElementById('path').innerHTML = result;

		fn_show_tag('dialog_bg', true);
	},

	// Select file
	select_file: function(file, type)
	{
		this.hide_perms_dialog();

		this.selected_file = file;
		if (file != '..') {
			document.getElementById('selected_file').innerHTML = file;
			document.getElementById('actions_table').style.display = ''; 
			document.getElementById('file_actions').style.display = (type == 'F') ? '' : 'none'; 
		} else {
			document.getElementById('selected_file').innerHTML = '';
			document.getElementById('actions_table').style.display = 'none';
		}

		if (document.getElementById('row_'+file)) {
			document.getElementById('row_'+file).style.background = '#96C2F7';
		}

		for (var k in this.directory_data) {
			if (file != k) {
				document.getElementById('row_'+k).style.background = '#FFFFFF';
			}
		}
	},

	// Rename file or directory
	rename: function()
	{
		this.hide_perms_dialog();

		if (this.selected_file.length > 0) {
			var rename_to = prompt(lang.text_enter_filename, this.selected_file);
			if (rename_to) {
				fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'=rename_file&file='+this.selected_file+'&rename_to='+rename_to, '', '', '', this.refresh.bind(this), false);
			}
		}
	},

	// Delete file or directory
	delete_file: function()
	{
		this.hide_perms_dialog();

		if (this.selected_file.length > 0) {
			if (confirm(lang.text_are_you_sure_to_proceed)) {
				fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'=delete_file&file='+this.selected_file, '', '', '', this.refresh.bind(this), false);
			}
		}
	},

	// Create file or directory
	create_file: function(file, is_dir)
	{
		this.hide_perms_dialog();

		if (file.length > 0) {
			var action = (is_dir == true) ? 'create_directory' : 'create_file';
			fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'='+action+'&file='+file, '', '', '', this.refresh.bind(this), false);
		}
	},

	// Download selected file
	get_file: function()
	{
		this.hide_perms_dialog();

		fn_redirect(index_script+'?'+target_name+'=template_editor&'+mode_name+'=get_file&file='+this.selected_file);
	},

	// Change file/directory permissions
	chmod: function(perms, recursive)
	{
		this.hide_perms_dialog();

		if (this.selected_file.length > 0) {
			if (perms) {
				fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'=chmod&file='+this.selected_file+'&perms='+perms+'&r='+recursive, '', '', '', this.refresh.bind(this), false);
			}
		}
	},

	show_perms_dialog: function()
	{
		this.parse_permissions();
		var wnd_sizes = fn_get_window_sizes();
		var dlg = document.getElementById('template_editor_perms');
		dlg.style.top = wnd_sizes['offset_y'] + (wnd_sizes['view_height'] - parseInt(dlg.style.height)) / 2;
		dlg.style.left = wnd_sizes['offset_x'] + (wnd_sizes['view_width'] - parseInt(dlg.style.width)) / 2;
		dlg.style.display = '';
	},

	hide_perms_dialog: function()
	{
		document.getElementById('template_editor_perms').style.display = 'none';
	},

	show_status: function(type, message, window_handle)
	{
		var wh = (window_handle) ? window_handle : document;

		if (!message) {
			if (wh.getElementById('error_box'))
				wh.getElementById('error_box').style.display = "none";
			if (wh.getElementById('status_box'))
				wh.getElementById('status_box').style.display = "none";
		} else {
			if (type == 'error') {
				if (wh.getElementById('error_status'))
					wh.getElementById('error_status').innerHTML = message;
				if (wh.getElementById('status_box'))
					wh.getElementById('status_box').style.display = "none";
				if (wh.getElementById('error_box'))
					wh.getElementById('error_box').style.display = "";
			} else {
				if (wh.getElementById('status'))
					wh.getElementById('status').innerHTML = message;
				if (wh.getElementById('error_box'))
					wh.getElementById('error_box').style.display = "none";
				if (wh.getElementById('status_box'))
					wh.getElementById('status_box').style.display = "";
			}
		}
		return true;
	},

	// Restore file from the repository
	restore_file: function()
	{
		if (this.selected_file.length > 0) {
			fn_ajax_http_request(index_script+'?'+target_name+'=template_editor&'+mode_name+'=restore&file='+this.selected_file, '', '', '', this.refresh.bind(this), false);
		}
	},

	parse_permissions: function()
	{
		var perms = this.directory_data[this.selected_file].perms;

		document.getElementById('o_read').checked = (perms.charAt(0) == '-') ? false : true;
		document.getElementById('o_write').checked = (perms.charAt(1) == '-') ? false : true;
		document.getElementById('o_exec').checked = (perms.charAt(2) == '-') ? false : true;
		document.getElementById('g_read').checked = (perms.charAt(3) == '-') ? false : true;
		document.getElementById('g_write').checked = (perms.charAt(4) == '-') ? false : true;
		document.getElementById('g_exec').checked = (perms.charAt(5) == '-') ? false : true;
		document.getElementById('w_read').checked = (perms.charAt(6) == '-') ? false : true;
		document.getElementById('w_write').checked = (perms.charAt(7) == '-') ? false : true;
		document.getElementById('w_exec').checked = (perms.charAt(8) == '-') ? false : true;
	},

	set_perms: function()
	{
		var mode = 0;
		mode = document.getElementById('o_read').checked ? mode + 400 : mode;
		mode = document.getElementById('o_write').checked ? mode + 200 : mode;
		mode = document.getElementById('o_exec').checked ? mode + 100 : mode;
		mode = document.getElementById('g_read').checked ? mode + 40 : mode;
		mode = document.getElementById('g_write').checked ? mode + 20 : mode;
		mode = document.getElementById('g_exec').checked ? mode + 10 : mode;
		mode = document.getElementById('w_read').checked ? mode + 4 : mode;
		mode = document.getElementById('w_write').checked ? mode + 2 : mode;
		mode = document.getElementById('w_exec').checked ? mode + 1 : mode;
		this.chmod(mode, document.getElementById('chmod_recursive').checked);
	}
}