<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty array split function plugin
 *
 * Type:     function<br>
 * Name:     include_addons_scripts<br>
 * Purpose:  function includes all javascripts from add-ons 
 * @return string
 */

function smarty_function_include_addons_scripts($params, &$smarty)
{
    require_once $smarty->_get_plugin_filepath('function','fetch');
    	
	global $settings, $skin_name;
	
	$scripts = '';
	$addons_dir = CSCART_DIR . DS . SKINS_REL_DIR . $skin_name .DS. AREA_NAME .DS. 'addons' . DS;
	$addons_host_dir = CSCART_HOST_DIR . DS .SKINS_REL_DIR . $skin_name . DS . AREA_NAME . DS . 'addons' . DS;	
	
	foreach ($settings['Addons'] as $k => $v) {
		if ($v == 'Y') {
			if (file_exists($addons_dir . $k . DS . 'scripts' . DS . 'config.js.tpl')) {
				$scripts .="\n". $smarty->fetch($addons_dir . $k . DS . 'scripts' . DS . 'config.js.tpl');
			}
			if (file_exists($addons_dir . $k . DS . 'scripts' . DS . 'config.js')) {
				$scripts .="\n".'<script type="text/javascript" language="javascript 1.2" src="' . $addons_host_dir . $k . DS . 'scripts' . DS . 'config.js"></script>';
			}
			if (file_exists($addons_dir . $k . DS . 'scripts' . DS . 'func.js')) {
				$scripts .="\n".'<script type="text/javascript" language="javascript 1.2" src="' . $addons_host_dir . $k . DS . 'scripts' . DS . 'func.js"></script>';
			}			
		}
	}
	return $scripts;
}

/* vim: set expandtab: */

?>
