<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty plugin
 * -------------------------------------------------------------
 * Type:     modifier<br>
 * Name:     to_json<br>
 * Purpose:  converts php array to javascript object notation 
 * Example:  {$a|to_json}
 * -------------------------------------------------------------
 */

function smarty_modifier_to_json($data)
{
	if (is_null($data)) {
		$content = 'null';
	} elseif ($data === false) {
		$content = 'false';
	} elseif ($data === true) {
		$content = 'true';
	} elseif (is_array($data)) {
		$content = '';
		foreach ($data as $key => $value) {
			$content .= (empty($content) ? '' : ', ') . "'$key'" . ':' . smarty_modifier_to_json($value);
		}
		$content = '{' . $content . '}';
	} else {
		$content = empty($data) ? "''" : (is_string($data) ? "'" . fn_js_escape($data) . "'" : $data);
	}

	return $content;
}

/* vim: set expandtab: */
?>