DROP TABLE IF EXISTS cscart_access_restriction_block;
CREATE TABLE `cscart_access_restriction_block` (
  `ip` int(11) NOT NULL default '0',
  `tries` int(11) NOT NULL default '0',
  `timestamp` int(11) NOT NULL default '0',
  `expires` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ip`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_access_restriction_emailcc;
CREATE TABLE `cscart_access_restriction_emailcc` (
  `item_id` int(11) unsigned NOT NULL auto_increment,
  `value` varchar(66) NOT NULL default '',
  `type` char(3) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  `timestamp` int(11) NOT NULL default '0',
  PRIMARY KEY  (`item_id`),
  KEY `type` (`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_access_restriction_ips;
CREATE TABLE `cscart_access_restriction_ips` (
  `item_id` int(11) unsigned NOT NULL auto_increment,
  `ip_from` int(11) NOT NULL default '0',
  `ip_to` int(11) NOT NULL default '0',
  `type` char(3) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  `timestamp` int(11) NOT NULL default '0',
  `expires` int(11) NOT NULL default '0',
  PRIMARY KEY  (`item_id`),
  KEY `type` (`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_access_restriction_reason_descriptions;
CREATE TABLE `cscart_access_restriction_reason_descriptions` (
  `item_id` int(11) unsigned NOT NULL auto_increment,
  `type` char(3) NOT NULL default '',
  `reason` text NOT NULL,
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`item_id`,`type`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_ad_descriptions;
CREATE TABLE `cscart_ad_descriptions` (
  `ad_id` int(11) unsigned NOT NULL auto_increment,
  `ad` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`ad_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_ads;
CREATE TABLE `cscart_ads` (
  `ad_id` int(11) unsigned NOT NULL auto_increment,
  `url` varchar(255) NOT NULL default '',
  `owner_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'G',
  `location` char(1) NOT NULL default 'L',
  `show_order` char(1) NOT NULL default 'B',
  `home_page_only` char(1) NOT NULL default 'Y',
  `target` char(1) NOT NULL default '',
  `timestamp` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ad_id`),
  KEY `position` (`position`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_aff_action_links;
CREATE TABLE `cscart_aff_action_links` (
  `action_id` int(11) unsigned NOT NULL default '0',
  `object_data` varchar(255) NOT NULL default '',
  `object_type` char(1) NOT NULL default '',
  PRIMARY KEY  (`action_id`,`object_type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_aff_banner_descriptions;
CREATE TABLE `cscart_aff_banner_descriptions` (
  `banner_id` int(11) unsigned NOT NULL default '0',
  `title` varchar(64) NOT NULL default '',
  `content` varchar(255) NOT NULL default '',
  `alt` varchar(64) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`banner_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_aff_banners;
CREATE TABLE `cscart_aff_banners` (
  `banner_id` int(11) unsigned NOT NULL auto_increment,
  `width` int(4) unsigned NOT NULL default '120',
  `height` int(4) unsigned NOT NULL default '60',
  `type` char(1) NOT NULL default 'T',
  `link_to` char(1) NOT NULL default 'U',
  `data` varchar(255) NOT NULL default '',
  `show_title` char(1) NOT NULL default 'Y',
  `text_location` char(1) NOT NULL default 'B',
  `new_window` char(1) NOT NULL default 'N',
  `to_cart` char(1) NOT NULL default 'N',
  `show_url` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`banner_id`),
  KEY `type_linkto` (`type`,`link_to`)
) TYPE=MyISAM ROW_FORMAT=DYNAMIC COMMENT='type: T - text, G - Graphic, P - product, C - category';

DROP TABLE IF EXISTS cscart_aff_group_descriptions;
CREATE TABLE `cscart_aff_group_descriptions` (
  `group_id` int(11) unsigned NOT NULL default '0',
  `name` char(64) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`group_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_aff_groups;
CREATE TABLE `cscart_aff_groups` (
  `group_id` int(11) unsigned NOT NULL auto_increment,
  `link_to` char(1) NOT NULL default 'U',
  `data` char(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`group_id`),
  KEY `link_to` (`link_to`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_aff_partner_actions;
CREATE TABLE `cscart_aff_partner_actions` (
  `action_id` int(11) unsigned NOT NULL auto_increment,
  `banner_id` int(11) unsigned NOT NULL default '0',
  `partner_id` int(11) unsigned NOT NULL default '0',
  `plan_id` int(11) unsigned NOT NULL default '0',
  `customer_id` int(11) unsigned NOT NULL default '0',
  `date` int(11) unsigned NOT NULL default '0',
  `ip` varchar(255) NOT NULL default '',
  `action` varchar(32) NOT NULL default '',
  `amount` decimal(12,2) NOT NULL default '0.00',
  `approved` char(1) NOT NULL default 'N',
  `payout_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`action_id`),
  KEY `parnerid_approved_date_payoutid` (`partner_id`,`approved`,`date`,`payout_id`,`amount`),
  KEY `action_date_amount_approved_payoutid` (`action`,`date`,`amount`,`approved`,`payout_id`),
  KEY `data_approved_payoutid` (`approved`,`payout_id`),
  KEY `amount` (`amount`),
  KEY `partnerid_date` (`partner_id`,`date`),
  KEY `payout_id` (`payout_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_aff_partner_profiles;
CREATE TABLE `cscart_aff_partner_profiles` (
  `user_id` int(11) unsigned NOT NULL default '0',
  `approved` char(1) NOT NULL default 'N',
  `plan_id` int(11) unsigned NOT NULL default '0',
  `balance` decimal(12,2) NOT NULL default '0.00',
  `referrer_partner_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_affiliate_payouts;
CREATE TABLE `cscart_affiliate_payouts` (
  `payout_id` int(11) unsigned NOT NULL auto_increment,
  `partner_id` int(11) unsigned NOT NULL default '0',
  `amount` decimal(12,2) NOT NULL default '0.00',
  `date` int(11) unsigned NOT NULL default '0',
  `status` char(1) NOT NULL default 'O',
  PRIMARY KEY  (`payout_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_affiliate_plans;
CREATE TABLE `cscart_affiliate_plans` (
  `plan_id` int(11) unsigned NOT NULL auto_increment,
  `payout_types` text NOT NULL,
  `commissions` varchar(255) NOT NULL default '',
  `min_payment` decimal(12,2) NOT NULL default '0.00',
  `product_ids` text NOT NULL,
  `category_ids` text NOT NULL,
  `discount_ids` text NOT NULL,
  `cookie_expiration` int(11) unsigned NOT NULL default '0',
  `method_based_selling_price` char(1) NOT NULL default 'N',
  `show_orders` char(1) NOT NULL default 'N',
  `use_coupon_commission` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`plan_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_also_bought_products;
CREATE TABLE `cscart_also_bought_products` (
  `product_id` int(11) unsigned NOT NULL default '0',
  `related_id` int(11) unsigned NOT NULL default '0',
  `amount` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`related_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_categories;
CREATE TABLE `cscart_categories` (
  `category_id` int(11) unsigned NOT NULL auto_increment,
  `parent_id` int(11) unsigned NOT NULL default '0',
  `id_path` varchar(255) NOT NULL default '',
  `owner_id` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `product_count` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `is_op` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`category_id`),
  KEY `c_avail` (`membership_id`,`avail`,`parent_id`),
  KEY `position` (`position`),
  KEY `parent` (`parent_id`),
  KEY `id_path` (`id_path`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_category_descriptions;
CREATE TABLE `cscart_category_descriptions` (
  `category_id` int(11) unsigned NOT NULL auto_increment,
  `lang_code` char(2) NOT NULL default 'EN',
  `category` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `meta_keywords` varchar(255) NOT NULL default '',
  `meta_description` varchar(255) NOT NULL default '',
  `page_title` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`category_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_category_images;
CREATE TABLE `cscart_category_images` (
  `image_id` int(11) unsigned NOT NULL auto_increment,
  `image` mediumblob NOT NULL,
  `image_path` varchar(255) NOT NULL default '',
  `image_type` varchar(64) NOT NULL default 'image/jpeg',
  `image_x` int(11) unsigned NOT NULL default '0',
  `image_y` int(11) unsigned NOT NULL default '0',
  `image_size` int(11) unsigned NOT NULL default '0',
  `alt` varchar(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`image_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_category_images_links;
CREATE TABLE `cscart_category_images_links` (
  `pair_id` int(11) unsigned NOT NULL auto_increment,
  `category_id` int(11) unsigned NOT NULL default '0',
  `image_id` int(11) unsigned NOT NULL default '0',
  `detailed_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pair_id`),
  KEY `pairs` (`image_id`,`detailed_id`),
  KEY `itype` (`category_id`,`type`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_common_descriptions;
CREATE TABLE `cscart_common_descriptions` (
  `object_id` varchar(128) NOT NULL default '',
  `object_type` varchar(64) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `object` varchar(128) NOT NULL default '',
  `object_table` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`object_id`,`lang_code`,`object_table`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_common_images;
CREATE TABLE `cscart_common_images` (
  `image_id` int(11) unsigned NOT NULL auto_increment,
  `image` mediumblob NOT NULL,
  `image_path` varchar(255) NOT NULL default '',
  `image_type` varchar(64) NOT NULL default 'image/jpeg',
  `image_x` int(11) unsigned NOT NULL default '0',
  `image_y` int(11) unsigned NOT NULL default '0',
  `image_size` int(11) unsigned NOT NULL default '0',
  `alt` varchar(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`image_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_common_images_links;
CREATE TABLE `cscart_common_images_links` (
  `pair_id` int(11) unsigned NOT NULL auto_increment,
  `object_id` int(11) unsigned NOT NULL default '0',
  `image_id` int(11) unsigned NOT NULL default '0',
  `detailed_id` int(11) unsigned NOT NULL default '0',
  `object_table` varchar(128) NOT NULL default '',
  `type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pair_id`),
  KEY `image_id` (`image_id`,`detailed_id`),
  KEY `itype` (`type`,`object_table`),
  KEY `position` (`position`),
  KEY `ti` (`object_table`,`object_id`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_class_descriptions;
CREATE TABLE `cscart_conf_class_descriptions` (
  `class_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `class_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`class_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_class_products;
CREATE TABLE `cscart_conf_class_products` (
  `class_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  KEY `class_id` (`class_id`,`product_id`),
  KEY `product_id` (`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_classes;
CREATE TABLE `cscart_conf_classes` (
  `class_id` int(11) unsigned NOT NULL auto_increment,
  `avail` char(1) NOT NULL default 'Y',
  `group_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`class_id`),
  KEY `group_id` (`group_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_compatible_classes;
CREATE TABLE `cscart_conf_compatible_classes` (
  `master_class_id` int(11) unsigned NOT NULL default '0',
  `slave_class_id` int(11) unsigned NOT NULL default '0',
  KEY `master_class_id` (`master_class_id`,`slave_class_id`),
  KEY `slave_class_id` (`slave_class_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_group_descriptions;
CREATE TABLE `cscart_conf_group_descriptions` (
  `group_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `configurator_group_name` varchar(255) NOT NULL default '',
  `full_description` text NOT NULL,
  PRIMARY KEY  (`group_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_group_images;
CREATE TABLE `cscart_conf_group_images` (
  `image_id` int(11) unsigned NOT NULL auto_increment,
  `image` mediumblob NOT NULL,
  `image_path` varchar(255) NOT NULL default '',
  `image_type` varchar(64) NOT NULL default 'image/jpeg',
  `image_x` int(11) unsigned NOT NULL default '0',
  `image_y` int(11) unsigned NOT NULL default '0',
  `image_size` int(11) unsigned NOT NULL default '0',
  `alt` varchar(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`image_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_group_images_links;
CREATE TABLE `cscart_conf_group_images_links` (
  `pair_id` int(11) unsigned NOT NULL auto_increment,
  `conf_group_id` int(11) unsigned NOT NULL default '0',
  `image_id` int(11) unsigned NOT NULL default '0',
  `detailed_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pair_id`),
  KEY `pairs` (`image_id`,`detailed_id`),
  KEY `itype` (`conf_group_id`,`type`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_group_products;
CREATE TABLE `cscart_conf_group_products` (
  `group_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  KEY `group_id` (`group_id`,`product_id`),
  KEY `product_id` (`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_groups;
CREATE TABLE `cscart_conf_groups` (
  `group_id` int(11) unsigned NOT NULL auto_increment,
  `configurator_group_type` char(1) NOT NULL default 'S',
  `avail` char(1) NOT NULL default 'Y',
  `step_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`group_id`),
  KEY `step_id` (`step_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_product_groups;
CREATE TABLE `cscart_conf_product_groups` (
  `product_id` int(11) unsigned NOT NULL default '0',
  `group_id` int(11) unsigned NOT NULL default '0',
  `default_product_ids` varchar(255) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  `required` char(1) NOT NULL default 'N',
  KEY `group_id` (`group_id`,`product_id`,`required`),
  KEY `product_id` (`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_step_descriptions;
CREATE TABLE `cscart_conf_step_descriptions` (
  `step_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `step_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`step_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_conf_steps;
CREATE TABLE `cscart_conf_steps` (
  `step_id` int(11) unsigned NOT NULL auto_increment,
  `position` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`step_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_countries;
CREATE TABLE `cscart_countries` (
  `code` char(2) NOT NULL default '',
  `code_A3` char(3) NOT NULL default '',
  `code_N3` int(4) NOT NULL default '0',
  `region` char(2) NOT NULL default '',
  `lat` float NOT NULL default '0',
  `lon` float NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`code`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_country_descriptions;
CREATE TABLE `cscart_country_descriptions` (
  `code` char(2) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `country` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`code`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_currencies;
CREATE TABLE `cscart_currencies` (
  `currency_code` varchar(10) NOT NULL default '',
  `after` char(1) NOT NULL default 'N',
  `symbol` varchar(30) NOT NULL default '',
  `coefficient` float(12,3) NOT NULL default '1.000',
  `is_primary` char(1) NOT NULL default 'N',
  `decimals_separator` char(1) NOT NULL default '.',
  `thousands_separator` char(1) NOT NULL default ',',
  `decimals` int(11) NOT NULL default '2',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`currency_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_currency_descriptions;
CREATE TABLE `cscart_currency_descriptions` (
  `currency_code` varchar(10) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`currency_code`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_destination_descriptions;
CREATE TABLE `cscart_destination_descriptions` (
  `destination_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `destination` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`destination_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_destination_elements;
CREATE TABLE `cscart_destination_elements` (
  `element_id` int(11) unsigned NOT NULL auto_increment,
  `destination_id` int(11) unsigned NOT NULL default '0',
  `element` varchar(36) NOT NULL default '',
  `element_type` char(1) NOT NULL default 'S',
  PRIMARY KEY  (`element_id`),
  KEY `c_avail` (`destination_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_destinations;
CREATE TABLE `cscart_destinations` (
  `destination_id` int(11) unsigned NOT NULL auto_increment,
  `owner_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`destination_id`),
  KEY `c_avail` (`destination_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_detailed_images;
CREATE TABLE `cscart_detailed_images` (
  `image_id` int(11) unsigned NOT NULL auto_increment,
  `image` mediumblob NOT NULL,
  `image_path` varchar(255) NOT NULL default '',
  `image_type` varchar(64) NOT NULL default 'image/jpeg',
  `image_x` int(11) unsigned NOT NULL default '0',
  `image_y` int(11) unsigned NOT NULL default '0',
  `image_size` int(11) unsigned NOT NULL default '0',
  `alt` varchar(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`image_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discount_coupons_used;
CREATE TABLE `cscart_discount_coupons_used` (
  `discount_id` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `firstname` varchar(32) NOT NULL default '',
  `lastname` varchar(32) NOT NULL default '',
  `b_city` varchar(64) NOT NULL default '',
  `b_state` varchar(32) NOT NULL default '',
  `b_country` char(2) NOT NULL default '',
  `b_zipcode` varchar(32) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `ip_address` varchar(15) NOT NULL default '',
  KEY `discount_id` (`discount_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discount_descriptions;
CREATE TABLE `cscart_discount_descriptions` (
  `discount_id` int(11) unsigned NOT NULL default '0',
  `discount` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`discount_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discounts;
CREATE TABLE `cscart_discounts` (
  `discount_id` int(11) unsigned NOT NULL auto_increment,
  `coupon_code` char(255) NOT NULL default '',
  `discount_type` char(1) NOT NULL default 'D',
  `value` decimal(12,2) unsigned NOT NULL default '0.00',
  `value_type` char(1) NOT NULL default 'A',
  `times` int(11) unsigned NOT NULL default '1',
  `times_used` int(11) unsigned NOT NULL default '0',
  `once_per_customer` char(1) NOT NULL default 'N',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'G',
  `from_date` int(11) unsigned NOT NULL default '0',
  `to_date` int(11) unsigned NOT NULL default '0',
  `order_total` decimal(12,2) unsigned NOT NULL default '0.00',
  `amount` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`discount_id`),
  KEY `type` (`type`),
  KEY `avail` (`avail`),
  KEY `cc` (`coupon_code`,`discount_type`,`avail`),
  KEY `big` (`value_type`,`type`,`from_date`,`to_date`,`membership_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discounts_categories;
CREATE TABLE `cscart_discounts_categories` (
  `discount_id` int(11) unsigned NOT NULL default '0',
  `category_id` int(11) unsigned NOT NULL default '0',
  `subcategories` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`discount_id`,`category_id`),
  KEY `category_id` (`category_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discounts_products;
CREATE TABLE `cscart_discounts_products` (
  `discount_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`discount_id`,`product_id`),
  KEY `product_id` (`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discounts_users;
CREATE TABLE `cscart_discounts_users` (
  `discount_id` int(11) unsigned NOT NULL default '0',
  `user_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`discount_id`,`user_id`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discussion;
CREATE TABLE `cscart_discussion` (
  `thread_id` int(11) NOT NULL auto_increment,
  `object_id` int(11) NOT NULL default '0',
  `object_type` char(1) NOT NULL default '',
  `type` char(1) NOT NULL default 'D',
  PRIMARY KEY  (`thread_id`),
  UNIQUE KEY `object_id` (`object_id`,`object_type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discussion_messages;
CREATE TABLE `cscart_discussion_messages` (
  `message` text NOT NULL,
  `post_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`post_id`),
  KEY `thread_id` (`thread_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discussion_posts;
CREATE TABLE `cscart_discussion_posts` (
  `post_id` int(11) NOT NULL auto_increment,
  `thread_id` int(11) unsigned NOT NULL default '0',
  `name` varchar(128) NOT NULL default '',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `user_id` int(11) unsigned NOT NULL default '0',
  `ip_address` varchar(15) NOT NULL default '',
  `avail` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`post_id`),
  KEY `thread_id` (`thread_id`,`ip_address`),
  KEY `thread_id_2` (`thread_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_discussion_rating;
CREATE TABLE `cscart_discussion_rating` (
  `rating_value` int(1) NOT NULL default '0',
  `post_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`post_id`),
  KEY `thread_id` (`thread_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_ekeys;
CREATE TABLE `cscart_ekeys` (
  `object_id` int(11) unsigned NOT NULL default '0',
  `object_string` varchar(128) NOT NULL default '',
  `object_type` char(1) NOT NULL default 'R',
  `ekey` varchar(32) NOT NULL default '',
  `ttl` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`object_id`,`object_type`,`ekey`),
  UNIQUE KEY `object_string` (`object_string`,`object_type`,`ekey`),
  KEY `c_avail` (`ekey`,`object_type`,`ttl`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_exim_layouts;
CREATE TABLE `cscart_exim_layouts` (
  `layout_id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `cols` text NOT NULL,
  `pattern_id` varchar(128) NOT NULL default '',
  `active` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`layout_id`),
  KEY `pattern_id` (`pattern_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_form_descriptions;
CREATE TABLE `cscart_form_descriptions` (
  `object_id` int(11) unsigned NOT NULL default '0',
  `object_type` char(1) NOT NULL default 'E',
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`object_id`,`object_type`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_form_element_variants;
CREATE TABLE `cscart_form_element_variants` (
  `variant_id` int(11) unsigned NOT NULL auto_increment,
  `element_id` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`variant_id`),
  KEY `element_id` (`element_id`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_form_elements;
CREATE TABLE `cscart_form_elements` (
  `element_id` int(11) unsigned NOT NULL auto_increment,
  `form_id` int(11) unsigned NOT NULL default '0',
  `element_type` char(1) NOT NULL default 'I',
  `default_value` varchar(255) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  `required` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`element_id`),
  KEY `form_id` (`form_id`,`avail`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_forms;
CREATE TABLE `cscart_forms` (
  `form_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `is_secure` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'Y',
  `email` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`form_id`),
  UNIQUE KEY `name` (`name`),
  KEY `name_2` (`name`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_gift_certificates;
CREATE TABLE `cscart_gift_certificates` (
  `gift_cert_id` int(11) unsigned NOT NULL auto_increment,
  `gift_cert_code` varchar(255) NOT NULL default '',
  `sender` varchar(255) NOT NULL default '',
  `recipient` varchar(255) NOT NULL default '',
  `send_via` char(1) NOT NULL default 'E',
  `amount_type` char(1) NOT NULL default 'I',
  `amount` decimal(12,2) NOT NULL default '0.00',
  `email` varchar(128) NOT NULL default '',
  `address` varchar(255) NOT NULL default '',
  `address_2` varchar(255) NOT NULL default '',
  `city` varchar(255) NOT NULL default '',
  `state` varchar(32) NOT NULL default '',
  `country` char(2) NOT NULL default '',
  `zipcode` varchar(10) NOT NULL default '',
  `status` char(1) NOT NULL default 'P',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `phone` varchar(32) NOT NULL default '',
  `template` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  `products` text NOT NULL,
  PRIMARY KEY  (`gift_cert_id`),
  KEY `status` (`status`),
  KEY `timestamp` (`timestamp`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_gift_certificates_log;
CREATE TABLE `cscart_gift_certificates_log` (
  `log_id` int(11) unsigned NOT NULL auto_increment,
  `gift_cert_id` int(11) unsigned NOT NULL default '0',
  `area` char(1) NOT NULL default 'C',
  `user_id` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `amount` decimal(12,2) NOT NULL default '0.00',
  `debit` decimal(12,2) NOT NULL default '0.00',
  `products` text NOT NULL,
  `debit_products` text NOT NULL,
  PRIMARY KEY  (`log_id`),
  KEY `area` (`area`),
  KEY `user_id` (`user_id`),
  KEY `timestamp` (`timestamp`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_descriptions;
CREATE TABLE `cscart_giftreg_descriptions` (
  `object_id` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `object_type` char(1) NOT NULL default 'F',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`object_id`,`object_type`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_event_fields;
CREATE TABLE `cscart_giftreg_event_fields` (
  `event_id` int(11) unsigned NOT NULL default '0',
  `field_id` int(11) unsigned NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`event_id`,`field_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_event_products;
CREATE TABLE `cscart_giftreg_event_products` (
  `item_id` int(11) unsigned NOT NULL default '0',
  `event_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  `amount` int(11) unsigned NOT NULL default '0',
  `ordered_amount` int(11) unsigned NOT NULL default '0',
  `extra` text,
  PRIMARY KEY  (`item_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_event_subscribers;
CREATE TABLE `cscart_giftreg_event_subscribers` (
  `event_id` int(11) unsigned NOT NULL default '0',
  `name` varchar(128) NOT NULL default '',
  `email` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`event_id`,`email`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_events;
CREATE TABLE `cscart_giftreg_events` (
  `event_id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned NOT NULL default '0',
  `start_date` int(11) unsigned NOT NULL default '0',
  `end_date` int(11) unsigned NOT NULL default '0',
  `status` char(1) NOT NULL default 'A',
  `type` char(1) NOT NULL default 'P',
  `title` varchar(255) NOT NULL default '',
  `owner` varchar(128) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`event_id`),
  KEY `start_date` (`start_date`,`end_date`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_field_variants;
CREATE TABLE `cscart_giftreg_field_variants` (
  `variant_id` int(11) unsigned NOT NULL auto_increment,
  `field_id` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`variant_id`),
  KEY `field_id` (`field_id`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_giftreg_fields;
CREATE TABLE `cscart_giftreg_fields` (
  `field_id` int(11) unsigned NOT NULL auto_increment,
  `field_type` char(1) NOT NULL default 'I',
  `position` int(11) unsigned NOT NULL default '0',
  `required` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`field_id`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_language_values;
CREATE TABLE `cscart_language_values` (
  `lang_code` char(2) NOT NULL default 'EN',
  `name` varchar(64) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`lang_code`,`name`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_languages;
CREATE TABLE `cscart_languages` (
  `lang_code` char(2) NOT NULL default 'EN',
  `name` varchar(64) NOT NULL default '',
  `icon_id` int(11) unsigned NOT NULL default '0',
  `charset` varchar(16) NOT NULL default 'iso-8859-1',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_left_messages;
CREATE TABLE `cscart_lh_left_messages` (
  `message_id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `reply_date` int(11) NOT NULL default '0',
  `from_name` varchar(255) NOT NULL default '',
  `from_mail` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  `operator_id` int(11) NOT NULL default '0',
  `reply` text NOT NULL,
  `replied` int(1) NOT NULL default '0',
  PRIMARY KEY  (`message_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_messages;
CREATE TABLE `cscart_lh_messages` (
  `message_id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `direction` int(1) NOT NULL default '0',
  `from_id` varchar(255) NOT NULL default '0',
  `to_id` int(11) NOT NULL default '0',
  `text` text NOT NULL,
  PRIMARY KEY  (`message_id`),
  KEY `from_id` (`from_id`),
  KEY `to_id` (`to_id`),
  KEY `direction` (`direction`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_messages_map;
CREATE TABLE `cscart_lh_messages_map` (
  `self_id` int(11) NOT NULL default '0',
  `to_id` int(11) NOT NULL default '0',
  `new_messages` int(1) NOT NULL default '0',
  `last_message` int(11) NOT NULL default '0',
  `direction` int(5) NOT NULL default '0',
  KEY `to_id` (`to_id`),
  KEY `self_id` (`self_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_operators;
CREATE TABLE `cscart_lh_operators` (
  `operator_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `login` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `obsolete_time` int(11) NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `register_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`operator_id`),
  KEY `obsolete_time` (`obsolete_time`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_sessions;
CREATE TABLE `cscart_lh_sessions` (
  `session_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `ip` double NOT NULL default '0',
  `time_diff` bigint(11) NOT NULL default '0',
  `start_time` int(11) NOT NULL default '0',
  `obsolete_time` int(11) NOT NULL default '0',
  `last_message` int(11) NOT NULL default '0',
  `readdress` varchar(100) NOT NULL default '0',
  `chat_counter` int(5) NOT NULL default '0',
  PRIMARY KEY  (`session_id`),
  KEY `obsolete_time` (`obsolete_time`),
  KEY `ip` (`ip`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_type_notify;
CREATE TABLE `cscart_lh_type_notify` (
  `direction` int(2) NOT NULL default '0',
  `self_id` int(11) NOT NULL default '0',
  `to_id` int(11) NOT NULL default '0',
  `flag` int(5) NOT NULL default '0',
  KEY `self_id` (`self_id`),
  KEY `to_id` (`to_id`),
  KEY `type` (`direction`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_visitors;
CREATE TABLE `cscart_lh_visitors` (
  `visitor_id` int(11) NOT NULL auto_increment,
  `ip` double NOT NULL default '0',
  `start_time` int(11) NOT NULL default '0',
  `obsolete_time` int(11) NOT NULL default '0',
  `status` int(3) NOT NULL default '0',
  `operator_id` int(11) NOT NULL default '0',
  `assigned_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`visitor_id`),
  KEY `ip` (`ip`),
  KEY `obsolete_time` (`obsolete_time`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_visitors_log;
CREATE TABLE `cscart_lh_visitors_log` (
  `log_id` int(11) NOT NULL auto_increment,
  `visitor_id` int(11) NOT NULL default '0',
  `date` int(11) NOT NULL default '0',
  `event` int(5) NOT NULL default '0',
  `operator_id` int(11) NOT NULL default '0',
  `operator_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`log_id`),
  KEY `visitor_id` (`visitor_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_lh_visitors_notes;
CREATE TABLE `cscart_lh_visitors_notes` (
  `note_id` int(11) NOT NULL auto_increment,
  `visitor_id` int(11) NOT NULL default '0',
  `date` int(11) NOT NULL default '0',
  `operator_id` int(11) NOT NULL default '0',
  `note` text NOT NULL,
  `operator_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`note_id`),
  KEY `visitor_id` (`visitor_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_listmania_list_objects;
CREATE TABLE `cscart_listmania_list_objects` (
  `lm_id` int(11) unsigned NOT NULL default '0',
  `list_object_id` int(11) unsigned NOT NULL default '0',
  `related_id` int(11) unsigned NOT NULL default '0',
  `extra` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`lm_id`,`list_object_id`,`related_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_listmania_list_type_descriptions;
CREATE TABLE `cscart_listmania_list_type_descriptions` (
  `list_id` int(11) unsigned NOT NULL default '0',
  `list` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `lang_code` char(2) NOT NULL default '',
  PRIMARY KEY  (`list_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_listmania_list_types;
CREATE TABLE `cscart_listmania_list_types` (
  `list_id` int(11) unsigned NOT NULL auto_increment,
  `object` int(11) unsigned NOT NULL default '0',
  `list_object` int(11) unsigned NOT NULL default '0',
  `type` int(11) unsigned NOT NULL default '0',
  `appearance_box` int(11) unsigned NOT NULL default '0',
  `appearance_order` int(11) unsigned NOT NULL default '0',
  `appearance_type` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `show_item_number` char(1) NOT NULL default 'N',
  `add_to_cart` char(1) NOT NULL default 'N',
  `on_separate_page` char(1) NOT NULL default 'N',
  `simultaneous_add` char(1) NOT NULL default 'N',
  `last_days` int(11) unsigned NOT NULL default '1',
  `period` int(11) unsigned NOT NULL default '0',
  `scroller_direction` int(11) unsigned NOT NULL default '0',
  `move_delay` int(11) unsigned NOT NULL default '0',
  `pause_delay` int(11) unsigned NOT NULL default '0',
  `speed_factor` int(11) NOT NULL default '0',
  `item_quantity` int(11) unsigned NOT NULL default '1',
  PRIMARY KEY  (`list_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_listmania_lists;
CREATE TABLE `cscart_listmania_lists` (
  `lm_id` int(11) unsigned NOT NULL auto_increment,
  `list_id` int(11) unsigned NOT NULL default '0',
  `object_id` int(11) unsigned NOT NULL default '0',
  `enable` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`lm_id`),
  UNIQUE KEY `list_id` (`list_id`,`object_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_manufacturer_descriptions;
CREATE TABLE `cscart_manufacturer_descriptions` (
  `manufacturer_id` int(11) unsigned NOT NULL auto_increment,
  `manufacturer` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `page_title` varchar(255) NOT NULL default '',
  `meta_keywords` varchar(255) NOT NULL default '',
  `meta_description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`manufacturer_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_manufacturers;
CREATE TABLE `cscart_manufacturers` (
  `manufacturer_id` int(11) unsigned NOT NULL auto_increment,
  `url` varchar(255) NOT NULL default '',
  `owner_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`manufacturer_id`),
  KEY `position` (`position`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_membership_descriptions;
CREATE TABLE `cscart_membership_descriptions` (
  `membership_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `membership` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`membership_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_membership_privileges;
CREATE TABLE `cscart_membership_privileges` (
  `membership_id` int(11) NOT NULL default '0',
  `privilege` varchar(24) NOT NULL default '',
  PRIMARY KEY  (`membership_id`,`privilege`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_memberships;
CREATE TABLE `cscart_memberships` (
  `membership_id` int(11) unsigned NOT NULL auto_increment,
  `avail` char(1) NOT NULL default '',
  `type` char(1) NOT NULL default 'C',
  PRIMARY KEY  (`membership_id`),
  KEY `c_avail` (`membership_id`,`avail`),
  KEY `avail` (`avail`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_new_orders;
CREATE TABLE `cscart_new_orders` (
  `order_id` int(11) unsigned NOT NULL default '0',
  `user_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`order_id`,`user_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_news;
CREATE TABLE `cscart_news` (
  `news_id` int(11) NOT NULL auto_increment,
  `date` int(11) NOT NULL default '0',
  `separate` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`news_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_news_descriptions;
CREATE TABLE `cscart_news_descriptions` (
  `news_id` int(11) NOT NULL default '0',
  `news` varchar(128) NOT NULL default '',
  `description` text NOT NULL,
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`news_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_newsletters;
CREATE TABLE `cscart_newsletters` (
  `newsletter_id` int(11) NOT NULL auto_increment,
  `sent_date` int(11) NOT NULL default '0',
  `avail` char(1) NOT NULL default 'N',
  `status` char(1) NOT NULL default 'Q',
  PRIMARY KEY  (`newsletter_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_newsletters_descriptions;
CREATE TABLE `cscart_newsletters_descriptions` (
  `newsletter_id` int(11) NOT NULL default '0',
  `newsletter` varchar(128) NOT NULL default '',
  `body_html` text NOT NULL,
  `body_text` text NOT NULL,
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`newsletter_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_order_data;
CREATE TABLE `cscart_order_data` (
  `order_id` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default '',
  `data` text NOT NULL,
  PRIMARY KEY  (`order_id`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_order_details;
CREATE TABLE `cscart_order_details` (
  `item_id` int(11) unsigned NOT NULL default '0',
  `order_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  `product_code` varchar(32) NOT NULL default '',
  `price` decimal(12,2) NOT NULL default '0.00',
  `amount` int(11) unsigned NOT NULL default '0',
  `extra` text NOT NULL,
  PRIMARY KEY  (`item_id`,`order_id`),
  KEY `o_k` (`order_id`,`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_orders;
CREATE TABLE `cscart_orders` (
  `order_id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `total` decimal(12,2) NOT NULL default '0.00',
  `subtotal` decimal(12,2) NOT NULL default '0.00',
  `discount` decimal(12,2) NOT NULL default '0.00',
  `payment_surcharge` decimal(12,2) NOT NULL default '0.00',
  `shipping_cost` decimal(12,2) NOT NULL default '0.00',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `status` char(1) NOT NULL default 'O',
  `notes` text NOT NULL,
  `details` text NOT NULL,
  `title` varchar(32) NOT NULL default '',
  `firstname` varchar(32) NOT NULL default '',
  `lastname` varchar(32) NOT NULL default '',
  `company` varchar(255) NOT NULL default '',
  `b_title` varchar(32) NOT NULL default '',
  `b_firstname` varchar(128) NOT NULL default '',
  `b_lastname` varchar(128) NOT NULL default '',
  `b_address` varchar(64) NOT NULL default '',
  `b_address_2` varchar(64) NOT NULL default '',
  `b_city` varchar(64) NOT NULL default '',
  `b_county` varchar(32) NOT NULL default '',
  `b_state` varchar(32) NOT NULL default '',
  `b_country` char(2) NOT NULL default '',
  `b_zipcode` varchar(32) NOT NULL default '',
  `s_title` varchar(32) NOT NULL default '',
  `s_firstname` varchar(128) NOT NULL default '',
  `s_lastname` varchar(128) NOT NULL default '',
  `s_address` varchar(64) NOT NULL default '',
  `s_address_2` varchar(64) NOT NULL default '',
  `s_city` varchar(64) NOT NULL default '',
  `s_county` varchar(32) NOT NULL default '',
  `s_state` varchar(32) NOT NULL default '',
  `s_country` char(2) NOT NULL default '',
  `s_zipcode` varchar(32) NOT NULL default '',
  `phone` varchar(32) NOT NULL default '',
  `fax` varchar(32) NOT NULL default '',
  `url` varchar(32) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `payment_id` int(11) NOT NULL default '0',
  `tax_exempt` char(1) NOT NULL default 'N',
  `lang_code` char(2) NOT NULL default 'EN',
  `ip_address` varchar(15) NOT NULL default '',
  `repaid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`order_id`),
  KEY `timestamp` (`timestamp`),
  KEY `user_id` (`user_id`),
  KEY `status` (`status`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_page_descriptions;
CREATE TABLE `cscart_page_descriptions` (
  `page_id` varchar(32) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `page` varchar(255) NOT NULL default '',
  `short_description` text NOT NULL,
  `full_description` text NOT NULL,
  `search_keywords` varchar(255) NOT NULL default '',
  `meta_keywords` varchar(255) NOT NULL default '',
  `meta_description` varchar(255) NOT NULL default '',
  `page_title` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`page_id`,`lang_code`),
  KEY `page_id` (`page_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_pages;
CREATE TABLE `cscart_pages` (
  `page_inner_id` int(11) NOT NULL auto_increment,
  `page_id` varchar(32) NOT NULL default '',
  `page_type` char(1) NOT NULL default 'N',
  `owner_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `path` varchar(255) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `page_link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`page_inner_id`),
  UNIQUE KEY `page_id` (`page_id`),
  KEY `position` (`position`),
  KEY `c_avail` (`page_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_pages_topics;
CREATE TABLE `cscart_pages_topics` (
  `page_id` char(32) NOT NULL default '',
  `topic_id` int(11) unsigned NOT NULL default '0',
  `link_type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`topic_id`,`page_id`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_payment_descriptions;
CREATE TABLE `cscart_payment_descriptions` (
  `payment_id` int(11) unsigned NOT NULL default '0',
  `payment` varchar(128) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`payment_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_payment_processors;
CREATE TABLE `cscart_payment_processors` (
  `processor_id` int(11) unsigned NOT NULL auto_increment,
  `processor` varchar(255) NOT NULL default '',
  `processor_script` varchar(255) NOT NULL default '',
  `processor_template` varchar(255) NOT NULL default '',
  `admin_template` varchar(255) NOT NULL default '',
  `callback` char(1) NOT NULL default 'N',
  `checkout` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`processor_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_payments;
CREATE TABLE `cscart_payments` (
  `payment_id` int(11) unsigned NOT NULL auto_increment,
  `protocol` varchar(6) NOT NULL default 'http',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `template` varchar(128) NOT NULL default '',
  `script` varchar(128) NOT NULL default '',
  `processor_id` int(11) unsigned NOT NULL default '0',
  `params` text NOT NULL,
  `a_surcharge` decimal(12,3) NOT NULL default '0.000',
  `p_surcharge` decimal(12,3) NOT NULL default '0.000',
  PRIMARY KEY  (`payment_id`),
  KEY `c_avail` (`membership_id`,`avail`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_privilege_descriptions;
CREATE TABLE `cscart_privilege_descriptions` (
  `privilege` varchar(24) NOT NULL default '',
  `description` varchar(128) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `section` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`privilege`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_privileges;
CREATE TABLE `cscart_privileges` (
  `privilege` varchar(24) NOT NULL default '',
  `is_default` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`privilege`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_descriptions;
CREATE TABLE `cscart_product_descriptions` (
  `product_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `product` varchar(255) NOT NULL default '',
  `shortname` varchar(255) NOT NULL default '',
  `short_description` text NOT NULL,
  `full_description` text NOT NULL,
  `meta_keywords` varchar(255) NOT NULL default '',
  `meta_description` varchar(255) NOT NULL default '',
  `search_words` text NOT NULL,
  `page_title` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`product_id`,`lang_code`),
  FULLTEXT KEY `pr` (`product`),
  FULLTEXT KEY `shrt` (`short_description`),
  FULLTEXT KEY `full` (`full_description`),
  FULLTEXT KEY `pr_shrt` (`product`,`short_description`),
  FULLTEXT KEY `pr_full` (`product`,`full_description`),
  FULLTEXT KEY `shrt_full` (`short_description`,`full_description`),
  FULLTEXT KEY `pr_shrt_full` (`product`,`short_description`,`full_description`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_features;
CREATE TABLE `cscart_product_features` (
  `feature_id` int(11) unsigned NOT NULL auto_increment,
  `feature_type` char(1) NOT NULL default 'T',
  `hidden` char(1) NOT NULL default 'N',
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) unsigned NOT NULL default '0',
  `comparison` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`feature_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_features_descriptions;
CREATE TABLE `cscart_product_features_descriptions` (
  `feature_id` int(11) unsigned NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `default_value` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`feature_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_features_values;
CREATE TABLE `cscart_product_features_values` (
  `feature_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`product_id`,`feature_id`,`lang_code`),
  KEY `vl` (`value`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_features_variants_descriptions;
CREATE TABLE `cscart_product_features_variants_descriptions` (
  `variant_id` int(11) unsigned NOT NULL default '0',
  `feature_id` int(11) unsigned NOT NULL default '0',
  `variant` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  KEY `feature_id` (`feature_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_global_option_links;
CREATE TABLE `cscart_product_global_option_links` (
  `option_id` int(11) NOT NULL default '0',
  `product_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`option_id`,`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_images;
CREATE TABLE `cscart_product_images` (
  `image_id` int(11) unsigned NOT NULL auto_increment,
  `image` mediumblob NOT NULL,
  `image_path` varchar(255) NOT NULL default '',
  `image_type` varchar(64) NOT NULL default 'image/jpeg',
  `image_x` int(11) unsigned NOT NULL default '0',
  `image_y` int(11) unsigned NOT NULL default '0',
  `image_size` int(11) unsigned NOT NULL default '0',
  `alt` varchar(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`image_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_images_links;
CREATE TABLE `cscart_product_images_links` (
  `pair_id` int(11) unsigned NOT NULL auto_increment,
  `product_id` int(11) unsigned NOT NULL default '0',
  `image_id` int(11) unsigned NOT NULL default '0',
  `detailed_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pair_id`),
  KEY `pairs` (`image_id`,`detailed_id`),
  KEY `ptype` (`product_id`,`type`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_option_images_links;
CREATE TABLE `cscart_product_option_images_links` (
  `pair_id` int(11) unsigned NOT NULL auto_increment,
  `product_option_id` int(11) unsigned NOT NULL default '0',
  `image_id` int(11) unsigned NOT NULL default '0',
  `detailed_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pair_id`),
  KEY `pairs` (`image_id`,`detailed_id`),
  KEY `ptype` (`product_option_id`,`type`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_option_variants;
CREATE TABLE `cscart_product_option_variants` (
  `variant_id` int(11) unsigned NOT NULL auto_increment,
  `option_id` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  `modifier` decimal(9,3) NOT NULL default '0.000',
  `modifier_type` char(1) NOT NULL default 'A',
  `weight_modifier` decimal(9,3) NOT NULL default '0.000',
  `weight_modifier_type` char(1) NOT NULL default 'A',
  `point_modifier` decimal(9,3) NOT NULL default '0.000',
  `point_modifier_type` char(1) NOT NULL default 'A',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`variant_id`),
  KEY `position` (`position`),
  KEY `avail` (`avail`),
  KEY `option_id` (`option_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_option_variants_descriptions;
CREATE TABLE `cscart_product_option_variants_descriptions` (
  `variant_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `variant_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`variant_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_options;
CREATE TABLE `cscart_product_options` (
  `option_id` int(11) unsigned NOT NULL auto_increment,
  `product_id` int(11) unsigned NOT NULL default '0',
  `option_type` char(1) NOT NULL default 'S',
  `inventory` char(1) NOT NULL default 'Y',
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) unsigned NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`option_id`),
  KEY `c_avail` (`product_id`,`avail`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_options_descriptions;
CREATE TABLE `cscart_product_options_descriptions` (
  `option_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `option_name` varchar(64) NOT NULL default '',
  `option_text` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`option_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_options_exceptions;
CREATE TABLE `cscart_product_options_exceptions` (
  `product_id` int(11) unsigned NOT NULL default '0',
  `options_group_id` int(11) unsigned NOT NULL default '0',
  `combination` varchar(255) NOT NULL default '',
  KEY `poroduct` (`product_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_options_inventory;
CREATE TABLE `cscart_product_options_inventory` (
  `product_id` int(11) NOT NULL default '0',
  `product_code` varchar(32) NOT NULL default '',
  `combination_hash` int(11) unsigned NOT NULL default '0',
  `combination` varchar(255) NOT NULL default '',
  `amount` int(11) NOT NULL default '0',
  `temp` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`combination_hash`),
  KEY `pc` (`product_id`,`combination`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_point_prices;
CREATE TABLE `cscart_product_point_prices` (
  `point_price_id` int(11) unsigned NOT NULL auto_increment,
  `product_id` int(11) unsigned NOT NULL default '0',
  `point_price` int(11) NOT NULL default '0',
  `lower_limit` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`point_price_id`),
  UNIQUE KEY `unique_key` (`lower_limit`,`membership_id`,`product_id`),
  KEY `src_k` (`product_id`,`lower_limit`,`membership_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_prices;
CREATE TABLE `cscart_product_prices` (
  `price_id` int(11) unsigned NOT NULL auto_increment,
  `product_id` int(11) unsigned NOT NULL default '0',
  `price` decimal(12,2) NOT NULL default '0.00',
  `lower_limit` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `combination_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`price_id`),
  UNIQUE KEY `unique_key` (`lower_limit`,`membership_id`,`combination_id`,`product_id`),
  KEY `src_k` (`product_id`,`lower_limit`,`membership_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_product_sales;
CREATE TABLE `cscart_product_sales` (
  `category_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  `amount` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`category_id`,`product_id`),
  KEY `pa` (`product_id`,`amount`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_products;
CREATE TABLE `cscart_products` (
  `product_id` int(11) unsigned NOT NULL auto_increment,
  `product_code` varchar(32) NOT NULL default '',
  `product_type` char(1) NOT NULL default 'N',
  `owner_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `manufacturer_id` int(11) unsigned NOT NULL default '0',
  `list_price` decimal(12,2) NOT NULL default '0.00',
  `amount` int(11) NOT NULL default '0',
  `min_amount` int(11) unsigned NOT NULL default '0',
  `weight` decimal(12,2) NOT NULL default '0.00',
  `length` int(11) unsigned NOT NULL default '0',
  `width` int(11) unsigned NOT NULL default '0',
  `height` int(11) unsigned NOT NULL default '0',
  `shipping_freight` decimal(12,2) NOT NULL default '0.00',
  `low_avail_limit` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `is_edp` char(1) NOT NULL default 'N',
  `edp_shipping` char(1) NOT NULL default 'N',
  `tracking` char(1) NOT NULL default 'B',
  `free_shipping` char(1) NOT NULL default 'N',
  `feature_comparison` char(1) NOT NULL default 'N',
  `zero_price_action` char(1) NOT NULL default 'R',
  `is_pbp` char(1) NOT NULL default 'N',
  `is_op` char(1) NOT NULL default 'N',
  `is_oper` char(1) NOT NULL default 'N',
  `supplier_id` int(11) unsigned NOT NULL default '0',
  `is_returnable` char(1) NOT NULL default 'Y',
  `return_period` int(11) unsigned NOT NULL default '10',
  PRIMARY KEY  (`product_id`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_products_categories;
CREATE TABLE `cscart_products_categories` (
  `product_id` int(11) unsigned NOT NULL default '0',
  `category_id` int(11) unsigned NOT NULL default '0',
  `link_type` char(1) NOT NULL default 'M',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`category_id`,`product_id`),
  KEY `link_type` (`link_type`),
  KEY `position` (`position`),
  KEY `pt` (`product_id`,`link_type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_products_taxes;
CREATE TABLE `cscart_products_taxes` (
  `product_id` int(11) unsigned NOT NULL default '0',
  `tax_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`tax_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_profile_field_descriptions;
CREATE TABLE `cscart_profile_field_descriptions` (
  `object_id` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `object_type` char(1) NOT NULL default 'F',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`object_id`,`object_type`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_profile_field_values;
CREATE TABLE `cscart_profile_field_values` (
  `value_id` int(11) NOT NULL auto_increment,
  `field_id` int(11) NOT NULL default '0',
  `position` int(11) NOT NULL default '0',
  PRIMARY KEY  (`value_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_profile_fields;
CREATE TABLE `cscart_profile_fields` (
  `field_id` int(11) NOT NULL auto_increment,
  `field_name` varchar(32) NOT NULL default '',
  `profile_show` char(1) default 'N',
  `profile_required` char(1) default 'N',
  `checkout_show` char(1) default 'N',
  `checkout_required` char(1) default 'N',
  `partner_show` char(1) default 'N',
  `partner_required` char(1) default 'N',
  `supplier_show` char(1) default 'N',
  `supplier_required` char(1) default 'N',
  `field_type` char(1) NOT NULL default 'I',
  `position` int(11) NOT NULL default '0',
  `is_default` char(1) default 'N',
  `section` char(1) default 'C',
  `matching_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`field_id`),
  KEY `field_name` (`field_name`),
  KEY `checkout_show` (`checkout_show`,`field_type`),
  KEY `profile_show` (`profile_show`,`field_type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_profile_fields_data;
CREATE TABLE `cscart_profile_fields_data` (
  `object_id` int(11) NOT NULL default '0',
  `object_type` char(1) NOT NULL default 'U',
  `field_id` int(11) NOT NULL default '0',
  `value` varchar(255) NOT NULL default '0',
  PRIMARY KEY  (`object_id`,`object_type`,`field_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_promotion_actions;
CREATE TABLE `cscart_promotion_actions` (
  `action_id` int(11) unsigned NOT NULL auto_increment,
  `promotion_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default '',
  `avail` char(1) NOT NULL default 'N',
  `value` text NOT NULL,
  PRIMARY KEY  (`action_id`),
  UNIQUE KEY `promotion_type` (`promotion_id`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_promotion_condition_descriptions;
CREATE TABLE `cscart_promotion_condition_descriptions` (
  `condition_id` int(11) unsigned NOT NULL default '0',
  `condition` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`condition_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_promotion_condition_rules;
CREATE TABLE `cscart_promotion_condition_rules` (
  `rule_id` int(11) unsigned NOT NULL auto_increment,
  `promotion_id` int(11) unsigned NOT NULL default '0',
  `group_id` int(11) unsigned NOT NULL default '0',
  `rule` varchar(255) NOT NULL default '',
  `condition_id` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`rule_id`),
  KEY `position` (`promotion_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_promotion_conditions;
CREATE TABLE `cscart_promotion_conditions` (
  `condition_id` int(11) unsigned NOT NULL auto_increment,
  `promotion_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`condition_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_promotion_descriptions;
CREATE TABLE `cscart_promotion_descriptions` (
  `promotion_id` int(11) unsigned NOT NULL default '0',
  `promotion` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `description` text NOT NULL,
  PRIMARY KEY  (`promotion_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_promotions;
CREATE TABLE `cscart_promotions` (
  `promotion_id` int(11) unsigned NOT NULL auto_increment,
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) NOT NULL default '0',
  PRIMARY KEY  (`promotion_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_reward_point_changes;
CREATE TABLE `cscart_reward_point_changes` (
  `change_id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `amount` int(11) NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `action` char(1) NOT NULL default 'A',
  `reason` text NOT NULL,
  PRIMARY KEY  (`change_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_reward_points;
CREATE TABLE `cscart_reward_points` (
  `reward_point_id` int(11) unsigned NOT NULL auto_increment,
  `object_id` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `amount` int(11) unsigned NOT NULL default '0',
  `amount_type` char(1) NOT NULL default 'A',
  `object_type` char(1) NOT NULL default 'P',
  PRIMARY KEY  (`reward_point_id`),
  UNIQUE KEY `unique_key` (`object_id`,`membership_id`,`object_type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_rma_properties;
CREATE TABLE `cscart_rma_properties` (
  `property_id` int(11) unsigned NOT NULL auto_increment,
  `position` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default '',
  `type` char(1) NOT NULL default 'R',
  `update_totals_and_inventory` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`property_id`),
  KEY `c_avail` (`property_id`,`avail`),
  KEY `avail` (`avail`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_rma_property_descriptions;
CREATE TABLE `cscart_rma_property_descriptions` (
  `property_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `property` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`property_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_rma_return_products;
CREATE TABLE `cscart_rma_return_products` (
  `return_id` int(11) unsigned NOT NULL default '0',
  `item_id` int(11) unsigned NOT NULL default '0',
  `product_id` int(11) unsigned NOT NULL default '0',
  `reason` int(11) unsigned NOT NULL default '0',
  `amount` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'A',
  `price` decimal(12,2) NOT NULL default '0.00',
  `product_options` text,
  PRIMARY KEY  (`return_id`,`item_id`,`type`),
  KEY `reason` (`reason`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_rma_returns;
CREATE TABLE `cscart_rma_returns` (
  `return_id` int(11) unsigned NOT NULL auto_increment,
  `order_id` int(11) unsigned NOT NULL default '0',
  `user_id` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `action` int(11) unsigned NOT NULL default '0',
  `status` char(1) NOT NULL default 'O',
  `total_amount` int(11) unsigned NOT NULL default '0',
  `comment` text,
  `extra` text,
  PRIMARY KEY  (`return_id`),
  KEY `order_id` (`order_id`),
  KEY `timestamp` (`timestamp`),
  KEY `user_id` (`user_id`),
  KEY `status` (`status`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_seo_names;
CREATE TABLE `cscart_seo_names` (
  `name` varchar(255) NOT NULL default '',
  `object_id` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default '',
  PRIMARY KEY  (`object_id`,`type`),
  KEY `name` (`name`),
  KEY `type` (`name`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_sessions;
CREATE TABLE `cscart_sessions` (
  `session_id` varchar(32) NOT NULL default '',
  `expiry` int(11) unsigned NOT NULL default '0',
  `data` mediumblob,
  PRIMARY KEY  (`session_id`),
  KEY `src` (`session_id`,`expiry`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings;
CREATE TABLE `cscart_settings` (
  `option_id` int(11) unsigned NOT NULL auto_increment,
  `option_name` varchar(64) NOT NULL default '',
  `section_id` varchar(64) NOT NULL default '',
  `subsection_id` varchar(64) NOT NULL default '',
  `option_type` char(1) NOT NULL default 'I',
  `value` varchar(64) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  `is_global` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`option_id`),
  UNIQUE KEY `option_name` (`option_name`,`section_id`,`subsection_id`),
  KEY `is_global` (`is_global`),
  KEY `position` (`position`),
  KEY `section_id` (`section_id`,`subsection_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings_descriptions;
CREATE TABLE `cscart_settings_descriptions` (
  `object_id` int(11) unsigned NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `object_type` char(1) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `object_string_id` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`object_id`,`object_string_id`,`lang_code`,`object_type`),
  KEY `object_id` (`object_id`,`object_type`,`lang_code`),
  KEY `object_string_id` (`object_string_id`,`object_type`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings_elements;
CREATE TABLE `cscart_settings_elements` (
  `element_id` int(11) unsigned NOT NULL auto_increment,
  `section_id` varchar(64) NOT NULL default '',
  `subsection_id` varchar(64) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  `element_type` char(1) NOT NULL default '',
  `handler` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`element_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings_routines;
CREATE TABLE `cscart_settings_routines` (
  `option_id` int(11) unsigned NOT NULL default '0',
  `action_script` varchar(128) NOT NULL default '',
  `variants_function` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`option_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings_sections;
CREATE TABLE `cscart_settings_sections` (
  `section_id` varchar(64) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`section_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings_subsections;
CREATE TABLE `cscart_settings_subsections` (
  `subsection_id` varchar(64) NOT NULL default '',
  `section_id` varchar(64) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subsection_id`,`section_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_settings_variants;
CREATE TABLE `cscart_settings_variants` (
  `variant_id` int(11) unsigned NOT NULL auto_increment,
  `option_id` int(11) unsigned NOT NULL default '0',
  `variant_name` varchar(64) NOT NULL default '',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`variant_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shipping_descriptions;
CREATE TABLE `cscart_shipping_descriptions` (
  `shipping_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `shipping` varchar(255) NOT NULL default '',
  `delivery_time` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`shipping_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shipping_rates;
CREATE TABLE `cscart_shipping_rates` (
  `rate_id` int(11) unsigned NOT NULL auto_increment,
  `shipping_id` int(11) unsigned NOT NULL default '0',
  `destination_id` int(11) NOT NULL default '0',
  `rate_value` text NOT NULL,
  PRIMARY KEY  (`rate_id`),
  UNIQUE KEY `shipping_rate` (`shipping_id`,`destination_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shipping_service_descriptions;
CREATE TABLE `cscart_shipping_service_descriptions` (
  `service_id` int(11) unsigned NOT NULL auto_increment,
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`service_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shipping_services;
CREATE TABLE `cscart_shipping_services` (
  `service_id` int(11) unsigned NOT NULL auto_increment,
  `intershipper_code` char(3) NOT NULL default '',
  `fedex_code` char(2) NOT NULL default '',
  `ups_code` char(3) NOT NULL default '',
  `usps_code` varchar(64) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  `carrier` varchar(10) NOT NULL default '',
  `dhl_code` varchar(10) NOT NULL default '',
  `aup_code` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`service_id`),
  KEY `sa` (`service_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shippings;
CREATE TABLE `cscart_shippings` (
  `shipping_id` int(11) unsigned NOT NULL auto_increment,
  `destination` char(1) NOT NULL default 'I',
  `min_weight` decimal(12,2) NOT NULL default '0.00',
  `max_weight` decimal(12,2) NOT NULL default '0.00',
  `membership_id` int(11) NOT NULL default '0',
  `rate_calculation` char(1) NOT NULL default 'M',
  `service_id` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'N',
  UNIQUE KEY `shipping_id` (`shipping_id`),
  KEY `position` (`position`),
  KEY `c_avail` (`membership_id`,`min_weight`,`max_weight`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shippings_suppliers;
CREATE TABLE `cscart_shippings_suppliers` (
  `shipping_id` int(11) unsigned NOT NULL default '0',
  `supplier_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`shipping_id`,`supplier_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_shippings_taxes;
CREATE TABLE `cscart_shippings_taxes` (
  `shipping_id` int(11) unsigned NOT NULL default '0',
  `tax_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`shipping_id`,`tax_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_site_subscribers;
CREATE TABLE `cscart_site_subscribers` (
  `email` char(128) NOT NULL default '',
  `timestamp` int(11) NOT NULL default '0',
  `unsubscribe_key` char(128) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`email`),
  KEY `avail` (`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_sitemap_descriptions;
CREATE TABLE `cscart_sitemap_descriptions` (
  `object_id` int(11) unsigned NOT NULL default '0',
  `object_name` varchar(255) NOT NULL default '',
  `object_description` text NOT NULL,
  `object_type` char(1) NOT NULL default 'S',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`object_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_sitemap_links;
CREATE TABLE `cscart_sitemap_links` (
  `link_id` int(11) unsigned NOT NULL auto_increment,
  `link_href` varchar(255) NOT NULL default '',
  `section_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) unsigned NOT NULL default '0',
  `link_type` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`link_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_sitemap_sections;
CREATE TABLE `cscart_sitemap_sections` (
  `section_id` int(11) unsigned NOT NULL auto_increment,
  `avail` char(1) NOT NULL default 'Y',
  `section_type` varchar(255) NOT NULL default '1',
  `position` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`section_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_browsers;
CREATE TABLE `cscart_stat_browsers` (
  `browser_id` int(11) unsigned NOT NULL auto_increment,
  `browser` varchar(50) NOT NULL default '',
  `version` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`browser_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_filter_descriptions;
CREATE TABLE `cscart_stat_filter_descriptions` (
  `filter_id` int(11) unsigned NOT NULL default '0',
  `filter` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `lang_code` char(2) NOT NULL default '',
  UNIQUE KEY `filter_lang` (`filter_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_filters;
CREATE TABLE `cscart_stat_filters` (
  `filter_id` int(11) unsigned NOT NULL auto_increment,
  `include` char(1) NOT NULL default 'Y',
  `conditions` text NOT NULL,
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`filter_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_ip2nation;
CREATE TABLE `cscart_stat_ip2nation` (
  `ip` int(11) unsigned NOT NULL default '0',
  `country_code` char(2) NOT NULL default '',
  KEY `ip` (`ip`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_ips;
CREATE TABLE `cscart_stat_ips` (
  `ip_id` int(11) unsigned NOT NULL auto_increment,
  `ip` int(11) unsigned NOT NULL default '0',
  `country_code` char(2) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`ip_id`),
  KEY `country_code` (`country_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_languages;
CREATE TABLE `cscart_stat_languages` (
  `lang_code` varchar(5) NOT NULL default '',
  `language` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_product_search;
CREATE TABLE `cscart_stat_product_search` (
  `sess_id` int(11) unsigned NOT NULL default '0',
  `search_string` text NOT NULL,
  `md5` varchar(32) NOT NULL default '',
  `quantity` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`sess_id`,`md5`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_requests;
CREATE TABLE `cscart_stat_requests` (
  `req_id` int(11) unsigned NOT NULL auto_increment,
  `timestamp` int(11) unsigned NOT NULL default '0',
  `url` text NOT NULL,
  `title` varchar(255) NOT NULL default '',
  `https` char(1) NOT NULL default 'N',
  `loadtime` int(11) unsigned NOT NULL default '0',
  `sess_id` int(11) unsigned NOT NULL default '0',
  `request_type` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`req_id`),
  KEY `sess_id` (`sess_id`),
  KEY `request_type` (`request_type`),
  KEY `timestamp` (`timestamp`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_robots;
CREATE TABLE `cscart_stat_robots` (
  `robot_id` int(11) unsigned NOT NULL auto_increment,
  `id` varchar(64) NOT NULL default '',
  `name` varchar(128) NOT NULL default '',
  `cover_url` varchar(255) NOT NULL default '',
  `details_url` varchar(255) NOT NULL default '',
  `owner_name` varchar(128) NOT NULL default '',
  `owner_url` varchar(255) NOT NULL default '',
  `owner_email` varchar(64) NOT NULL default '',
  `status` varchar(64) NOT NULL default '',
  `purpose` varchar(64) NOT NULL default '',
  `type` varchar(64) NOT NULL default '',
  `platform` varchar(64) NOT NULL default '',
  `availability` varchar(64) NOT NULL default '',
  `exclusion` varchar(64) NOT NULL default '',
  `exclusion_useragent` varchar(255) NOT NULL default '',
  `noindex` varchar(64) NOT NULL default '',
  `host` varchar(32) NOT NULL default '',
  `robot_from` varchar(64) NOT NULL default '',
  `useragent` varchar(255) NOT NULL default '',
  `language` varchar(32) NOT NULL default '',
  `description` text NOT NULL,
  `history` text NOT NULL,
  `environment` varchar(64) NOT NULL default '',
  `modified_date` int(11) unsigned NOT NULL default '0',
  `modified_by` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`robot_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_search_engines;
CREATE TABLE `cscart_stat_search_engines` (
  `engine_id` int(11) unsigned NOT NULL auto_increment,
  `engine` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`engine_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_search_phrases;
CREATE TABLE `cscart_stat_search_phrases` (
  `phrase_id` int(11) unsigned NOT NULL auto_increment,
  `phrase` text NOT NULL,
  PRIMARY KEY  (`phrase_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_stat_sessions;
CREATE TABLE `cscart_stat_sessions` (
  `sess_id` int(11) unsigned NOT NULL auto_increment,
  `os` varchar(30) NOT NULL default '',
  `client_type` char(1) NOT NULL default 'U',
  `browser_id` int(11) unsigned NOT NULL default '0',
  `robot_id` int(11) unsigned NOT NULL default '0',
  `user_agent` varchar(255) NOT NULL default '',
  `screen_x` int(11) unsigned NOT NULL default '0',
  `screen_y` int(11) unsigned NOT NULL default '0',
  `color` int(11) unsigned NOT NULL default '0',
  `client_language` varchar(5) NOT NULL default '',
  `session` varchar(32) NOT NULL default '',
  `host_ip` int(11) unsigned NOT NULL default '0',
  `proxy_ip` int(11) unsigned NOT NULL default '0',
  `ip_id` int(11) unsigned NOT NULL default '0',
  `uniq_code` int(11) unsigned NOT NULL default '0',
  `referrer` text NOT NULL,
  `referrer_scheme` varchar(32) NOT NULL default '',
  `referrer_host` varchar(128) NOT NULL default '',
  `engine_id` int(11) unsigned NOT NULL default '0',
  `phrase_id` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `expiry` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`sess_id`),
  KEY `browser_id` (`browser_id`),
  KEY `ip_id` (`ip_id`),
  KEY `engine_id` (`engine_id`),
  KEY `phrase_id` (`phrase_id`),
  KEY `robot_id` (`robot_id`),
  KEY `timestamp` (`timestamp`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_state_descriptions;
CREATE TABLE `cscart_state_descriptions` (
  `state_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `state` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`state_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_states;
CREATE TABLE `cscart_states` (
  `state_id` int(11) unsigned NOT NULL auto_increment,
  `country_code` char(2) NOT NULL default '',
  `code` varchar(32) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`state_id`),
  UNIQUE KEY `cs` (`country_code`,`code`),
  KEY `code` (`code`),
  KEY `country_code` (`country_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_static_data;
CREATE TABLE `cscart_static_data` (
  `param_id` int(11) NOT NULL auto_increment,
  `param` varchar(255) NOT NULL default '',
  `param_2` varchar(255) NOT NULL default '',
  `param_3` varchar(255) NOT NULL default '',
  `param_4` varchar(255) NOT NULL default '',
  `section` char(1) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  `position` int(11) NOT NULL default '0',
  PRIMARY KEY  (`param_id`),
  KEY `section` (`section`,`avail`),
  KEY `position` (`position`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_static_data_descriptions;
CREATE TABLE `cscart_static_data_descriptions` (
  `param_id` int(11) NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `descr` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`param_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_elements;
CREATE TABLE `cscart_statistics_elements` (
  `element_id` int(11) unsigned NOT NULL auto_increment,
  `code` varchar(66) NOT NULL default '',
  `type` char(1) NOT NULL default 'O',
  `depend_on_it` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`element_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_intervals;
CREATE TABLE `cscart_statistics_intervals` (
  `interval_id` int(11) NOT NULL auto_increment,
  `value` int(11) NOT NULL default '0',
  `interval_code` varchar(66) NOT NULL default '',
  PRIMARY KEY  (`interval_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_report_descriptions;
CREATE TABLE `cscart_statistics_report_descriptions` (
  `report_id` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`report_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_reports;
CREATE TABLE `cscart_statistics_reports` (
  `report_id` int(11) unsigned NOT NULL auto_increment,
  `position` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `avail` char(1) NOT NULL default 'Y',
  `type` char(1) NOT NULL default '',
  `begin` int(11) NOT NULL default '0',
  `end` int(11) NOT NULL default '0',
  PRIMARY KEY  (`report_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_table_conditions;
CREATE TABLE `cscart_statistics_table_conditions` (
  `table_id` int(11) unsigned NOT NULL default '0',
  `code` varchar(66) NOT NULL default '0',
  `sub_element_id` varchar(11) NOT NULL default '0',
  PRIMARY KEY  (`table_id`,`code`,`sub_element_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_table_descriptions;
CREATE TABLE `cscart_statistics_table_descriptions` (
  `table_id` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`table_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_table_element_conditions;
CREATE TABLE `cscart_statistics_table_element_conditions` (
  `table_id` int(11) NOT NULL default '0',
  `element_hash` varchar(32) NOT NULL default '',
  `element_code` varchar(66) NOT NULL default '',
  `ids` varchar(11) NOT NULL default '',
  PRIMARY KEY  (`table_id`,`element_hash`,`ids`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_table_elements;
CREATE TABLE `cscart_statistics_table_elements` (
  `report_id` int(11) NOT NULL default '0',
  `table_id` int(11) NOT NULL default '0',
  `element_id` int(11) NOT NULL default '0',
  `element_hash` int(11) NOT NULL default '0',
  `color` varchar(66) NOT NULL default 'blueviolet',
  `position` int(11) NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `dependence` varchar(66) NOT NULL default 'max_p',
  `limit_auto` int(11) NOT NULL default '5',
  PRIMARY KEY  (`report_id`,`table_id`,`element_hash`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statistics_tables;
CREATE TABLE `cscart_statistics_tables` (
  `table_id` int(11) unsigned NOT NULL auto_increment,
  `report_id` int(11) NOT NULL default '0',
  `position` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default 'T',
  `display` varchar(66) NOT NULL default 'order_amount',
  `interval_id` int(11) NOT NULL default '0',
  `period` varchar(32) NOT NULL default '',
  `auto` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`table_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_status_data;
CREATE TABLE `cscart_status_data` (
  `status` char(1) NOT NULL default '',
  `type` char(1) NOT NULL default 'O',
  `param` char(255) NOT NULL default '',
  `value` char(255) NOT NULL default 'Y',
  PRIMARY KEY  (`status`,`type`,`param`),
  KEY `inventory` (`value`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_status_descriptions;
CREATE TABLE `cscart_status_descriptions` (
  `status` char(1) NOT NULL default '',
  `type` char(1) NOT NULL default 'O',
  `description` varchar(255) NOT NULL default '',
  `email_subj` varchar(255) NOT NULL default '',
  `email_header` text NOT NULL,
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`status`,`type`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_statuses;
CREATE TABLE `cscart_statuses` (
  `status` char(1) NOT NULL default '',
  `type` char(1) NOT NULL default 'O',
  PRIMARY KEY  (`status`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_tax_descriptions;
CREATE TABLE `cscart_tax_descriptions` (
  `tax_id` int(11) unsigned NOT NULL default '0',
  `lang_code` char(2) NOT NULL default 'EN',
  `tax` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`tax_id`,`lang_code`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_tax_rates;
CREATE TABLE `cscart_tax_rates` (
  `rate_id` int(11) unsigned NOT NULL auto_increment,
  `tax_id` int(11) unsigned NOT NULL default '0',
  `destination_id` int(11) NOT NULL default '0',
  `apply_to` varchar(64) NOT NULL default '',
  `rate_value` decimal(12,3) NOT NULL default '0.000',
  `rate_type` char(1) NOT NULL default '',
  `owner_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`rate_id`),
  UNIQUE KEY `tax_rate` (`tax_id`,`destination_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_taxes;
CREATE TABLE `cscart_taxes` (
  `tax_id` int(11) unsigned NOT NULL auto_increment,
  `address_type` char(1) NOT NULL default 'S',
  `avail` char(1) NOT NULL default 'N',
  `price_includes_tax` char(1) NOT NULL default 'N',
  `display_including_tax` char(1) NOT NULL default 'N',
  `display_info` char(1) NOT NULL default '',
  `regnumber` varchar(255) NOT NULL default '',
  `priority` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`tax_id`),
  KEY `c_avail` (`membership_id`,`avail`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_topic_descriptions;
CREATE TABLE `cscart_topic_descriptions` (
  `topic_id` int(11) unsigned NOT NULL auto_increment,
  `lang_code` char(2) NOT NULL default 'EN',
  `topic` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `meta_keywords` varchar(255) NOT NULL default '',
  `meta_description` varchar(255) NOT NULL default '',
  `search_keywords` varchar(255) NOT NULL default '',
  `page_title` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`topic_id`,`lang_code`),
  KEY `topic_id` (`topic_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_topics;
CREATE TABLE `cscart_topics` (
  `topic_id` int(11) unsigned NOT NULL auto_increment,
  `parent_id` int(11) unsigned NOT NULL default '0',
  `id_path` varchar(255) NOT NULL default '',
  `owner_id` int(11) unsigned NOT NULL default '0',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `avail` char(1) NOT NULL default 'Y',
  `page_count` int(11) unsigned NOT NULL default '0',
  `position` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`topic_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_user_data;
CREATE TABLE `cscart_user_data` (
  `user_id` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default '',
  `data` text NOT NULL,
  PRIMARY KEY  (`user_id`,`type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_user_profiles;
CREATE TABLE `cscart_user_profiles` (
  `profile_id` int(11) unsigned NOT NULL auto_increment,
  `user_id` int(11) unsigned NOT NULL default '0',
  `profile_type` char(1) NOT NULL default 'P',
  `b_title` varchar(32) NOT NULL default '',
  `b_firstname` varchar(128) NOT NULL default '',
  `b_lastname` varchar(128) NOT NULL default '',
  `b_address` varchar(64) NOT NULL default '',
  `b_address_2` varchar(64) NOT NULL default '',
  `b_city` varchar(64) NOT NULL default '',
  `b_county` varchar(32) NOT NULL default '',
  `b_state` varchar(32) NOT NULL default '',
  `b_country` char(2) NOT NULL default '',
  `b_zipcode` varchar(16) NOT NULL default '',
  `s_title` varchar(32) NOT NULL default '',
  `s_firstname` varchar(128) NOT NULL default '',
  `s_lastname` varchar(128) NOT NULL default '',
  `s_address` varchar(255) NOT NULL default '',
  `s_address_2` varchar(255) NOT NULL default '',
  `s_city` varchar(255) NOT NULL default '',
  `s_county` varchar(32) NOT NULL default '',
  `s_state` varchar(32) NOT NULL default '',
  `s_country` char(2) NOT NULL default '',
  `s_zipcode` varchar(16) NOT NULL default '',
  `profile_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`profile_id`),
  KEY `uid_p` (`user_id`,`profile_type`),
  KEY `profile_type` (`profile_type`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_user_session_products;
CREATE TABLE `cscart_user_session_products` (
  `user_id` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `type` char(1) NOT NULL default 'C',
  `item_id` int(11) unsigned NOT NULL default '0',
  `item_type` char(1) NOT NULL default 'P',
  `product_id` int(11) unsigned NOT NULL default '0',
  `amount` int(11) unsigned NOT NULL default '1',
  `price` decimal(12,2) NOT NULL default '0.00',
  `extra` text NOT NULL,
  PRIMARY KEY  (`user_id`,`type`,`item_id`)
) TYPE=MyISAM;

DROP TABLE IF EXISTS cscart_users;
CREATE TABLE `cscart_users` (
  `user_id` int(11) unsigned NOT NULL auto_increment,
  `active` char(1) NOT NULL default 'Y',
  `user_type` char(1) NOT NULL default 'Y',
  `user_login` varchar(255) NOT NULL default '',
  `membership_status` char(1) NOT NULL default 'P',
  `membership_id` int(11) unsigned NOT NULL default '0',
  `referer` varchar(255) NOT NULL default '',
  `last_login` int(11) unsigned NOT NULL default '0',
  `timestamp` int(11) unsigned NOT NULL default '0',
  `password` varchar(32) NOT NULL default '',
  `card_name` varchar(255) NOT NULL default '',
  `card_type` varchar(16) NOT NULL default '',
  `card_number` varchar(42) NOT NULL default '',
  `card_expire` varchar(4) NOT NULL default '',
  `card_cvv2` char(3) NOT NULL default '',
  `title` varchar(24) NOT NULL default '',
  `firstname` varchar(128) NOT NULL default '',
  `lastname` varchar(128) NOT NULL default '',
  `company` varchar(255) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `phone` varchar(32) NOT NULL default '',
  `fax` varchar(32) NOT NULL default '',
  `url` varchar(128) NOT NULL default '',
  `tax_exempt` char(1) NOT NULL default 'N',
  `lang_code` char(2) NOT NULL default 'EN',
  PRIMARY KEY  (`user_id`),
  KEY `user_login` (`user_login`),
  KEY `uname` (`title`,`firstname`,`lastname`)
) TYPE=MyISAM;

